Param(
  [string]$MSIP,
  [string]$user,
  [string]$password,
  [string]$nfspath,
  [string]$serviceTags
)
$datentime = Get-Date
Write-Host "$datentime :: Begin PowerShell execution of CallDiscov.ps1" 

$securepass = ConvertTo-SecureString -AsPlainText $password -Force
$cred = New-Object System.Management.Automation.PSCredential ($user, $securepass)

$datentime = Get-Date
Write-Host "$datentime :: Creating session"
$session = New-PSSession -ComputerName $MSIP -Authentication Negotiate -Credential $cred 
    
$datentime = Get-Date
Write-Host "$datentime :: Invoking command"

$serviceTagsList = $serviceTags.Split(",")

if($nfspath.Contains("CMC"))
{
Write-Host "CMCInvoke"
    Invoke-Command -Session $session -FilePath /usr/share/tomcatTejas/webapps/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/DiscoveryScriptCMC.ps1 -ArgumentList $nfspath,$serviceTagsList
}
elseif($nfspath.Contains("NGM"))
{
Write-Host "NGMInvoke"
    Invoke-Command -Session $session -FilePath /usr/share/tomcatTejas/webapps/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/DiscoveryScriptCMC.ps1 -ArgumentList $nfspath,$serviceTagsList
}
elseif($nfspath.Contains("Server"))
{
Write-Host "ServerInvoke"
    Invoke-Command -Session $session -FilePath /usr/share/tomcatTejas/webapps/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/discovJSON.ps1 -ArgumentList $nfspath,$serviceTagsList
}
elseif($nfspath.Contains("NetworkSwitch"))
{
Write-Host "NetworkSwitchInvoke"
    Invoke-Command -Session $session -FilePath /usr/share/tomcatTejas/webapps/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/NetworkSwitchDiscoveryScript.ps1 -ArgumentList $nfspath,$serviceTagsList
}

#Invoke-Command -Session $session -FilePath /usr/share/tomcatTejas/webapps/Spectre/WEB-INF/classes/com/dell/tejas/ig/ps/command/discovJSON.ps1 -ArgumentList $nfspath

$datentime = Get-Date
Write-Host "$datentime :: Removing session"
Remove-PSSession -Session $session
$datentime = Get-Date
Write-Host "$datentime :: Finished PowerShell execution of CallDiscov.ps1"

#   powershell /nfsstage/scom_scripts/CallDiscov.ps1 -MSIP "100.96.20.187" -user "administrator" -password "Dell123" -nfspath "\\\\100.96.20.101\nfsstage\json_share\"
