param($VMMServer,$DomainUsername,$DelPwd,$tejasFQDN,$OtherInfo)
## This script gets the logical network details from scvmm
$debug1 = 1

# Return Value
$returnval = @()
$temp = @("null") 
  
#$DelUserName='tejas\administrator'
#$DelPwd='Dell_123$'
#$VMMServer='scvmm.tejas.com'
#$libShare = '\\orchestrator.tejas.com\SCVMMLib'
#$uuid = '4c4c4544-0039-4810-8051-b2c04f383253'
#$stagingFolder = '\\scvmm.tejas.com\karthik'
#$VGUserName = "tejas\administrator"
#$VGPassword = "Dell_123$"
$stdFolder = '\Dell\Drivers'

# Create obj
Function Createcredobj($username, $passwd)
{

    try
    {
		$secpasswd = ConvertTo-SecureString  $passwd -AsPlainText -Force
        $mycredsobj = New-Object System.Management.Automation.PSCredential ($username, $secpasswd)
        #$Error
    }
    catch
    {
        $mycredsobj = $null
    }

    return $mycredsobj

}

#import SCVMM related cmdlets
import-module virtualmachinemanager

# Create SCVMM Cred obj    
   $scvmmcreds = Createcredobj $DomainUsername $DelPwd
    if ( $scvmmcreds -eq $null)
    {
        $returnval = $returnval + "FAIL"
		$returnval = $returnval + "Status:Could not create credentail object for the given SCVMM user"
        return $returnval
    }

# A user can have mutiple role, in Tejasconext we are connecting always as DelegatedAdmin Role.

    try 
    {
    	$OtherInfo = $OtherInfo -replace "\\n\\r", " "
    	$libShare=$OtherInfo.split(',')[0]
    	$uuid=$OtherInfo.split(',')[1]
    	$stdFolder=$OtherInfo.split(',')[2]
    }
    catch [exception]
    {
        $returnjson="Status:"+$Error[0].Exception
        $returnval = $returnval + "FAIL"
		$returnval = $returnval + $returnjson
        if ($debug1 -eq 0)
		{
			write-host $returnval
		}
		return $returnval
    }

    if ( $VMMobj -eq $null)
    {
    	$returnjson="Status:SCVMM host not reachable"
        $returnval = $returnval + "FAIL"
        $returnval = $returnval + $returnjson
        if ($debug1 -eq 0)
		{
			write-host $returnval
		}
		return $returnval
       
    }
	else
    {
		
		try
		{
			# get library server
            $ErrorActionPreference = "Stop";
            $libServer = Get-SCLibraryShare -VMMServer $VMMobj | where { $_.Path -eq $libShare } 		


		    # No lib server shrare found
			if ($libServer -eq $null )
			{
				if ($debug1 -eq 0)
				{
					write-host "No library share found for the given path in SCVMM"
				}
				$returnjson="Status:No library share found for in SCVMM for path"+ $libShare
				$returnval = $returnval + "FAIL"
				$returnval = $returnval + $returnjson
				
				return $returnval
				
			}
			else # Found some Lib server
			{
				if ($debug1 -eq 0)
				{
					write-host "library share found for the given path in SCVMM"
				}
                # Check if the folder structure exists else create
                $driverRootPath = $libShare + $stdFolder
                try
                {
                     if(!(Test-Path -Path $driverRootPath))
                      {
						
                        new-item -Path $driverRootPath itemtype directory | Out-Null
						
                      }
                }
                catch [exception]
		        {
					$returnjson="Status:Exception while creating root folders in library share "+$driverRootPath+" "+$_.Exception.Message
					$returnval = $returnval + "FAIL"
				    $returnval = $returnval + $returnjson
				

				    if ($debug1 -eq 0)
				    {
					    write-host $returnval
				    }
				    return $returnval
		        }
                
                # Refresh lib server (not reqd here)
                # Read-SCLibraryShare -LibraryShare $libServer

				# Check if the staging folder exists
				$tempStagingFolder = $stagingFolder + "\`$WinPEDriver`$\"
				
				# check if server folder already exists
                $serverFolder = $driverRootPath + '\' + $uuid
                try
                {
					  if((Test-Path -Path $serverFolder))
                      {
					     remove-item -Path $serverFolder -Force -Recurse| Out-Null
                      }
                      
                      new-item -Path $serverFolder itemtype directory| Out-Null
                     
                }
                catch [exception]
		        {
				    $returnjson="Status:Exception occured while creating/removing folder "+$serverFolder+" "+$_.Exception.Message
				    $returnval = $returnval + "FAIL"
				    $returnval = $returnval + $returnjson
				    if ($debug1 -eq 0)
				    {
					    write-host $returnval
				    }
				    return $returnval
		        }

				
                # Refresh lib server
                Read-SCLibraryShare -LibraryShare $libServer | Out-Null

				
                # Copy all the drivers from staging folder to Lib server folder
                try
                {
					#$tempStagingFolder = $tempStagingFolder + '*'
					Copy-Item $tempStagingFolder $serverFolder -recurse | Out-Null
					                    
                }
                catch [exception]
		        {
		        	$returnjson="Status:Exception occured while copying drivers from "+$tempStagingFolder+" to "+$serverFolder+" "+$_.Exception.Message
					$returnval = $returnval + "FAIL"
				    $returnval = $returnval + $returnjson
				

				    if ($debug1 -eq 0)
				    {
					    write-host $returnval
				    }
				    return $returnval
		        }
                
				
                 # Refresh lib server
                Read-SCLibraryShare -LibraryShare $libServer | Out-Null

                $returnval = $returnval + "SUCCESS"
				$returnval = $returnval + "Status:Completed copying LC drivers to Library Server successfully"
				

				if ($debug1 -eq 0)
				{
					write-host $returnval
				}
				return $returnval
			}

		}
		catch [exception]
		{
				$returnjson="Status:Exception occured while getting library share info for "+$libShare+" "+$_.Exception.Message
				$returnval = $returnval + "FAIL"
			    $returnval = $returnval + $returnjson
				

				if ($debug1 -eq 0)
				{
					write-host $returnval
				}
				return $returnval
		}

}