param($ComputerName,$DomainUsername,$DelPwd,$tejasFQDN,$SccmSmBiosGuid)

<#
$ComputerName = "sksccm.mydomain.com"
$DomainUsername = "mydomain\administrator"
$DelPwd = "Dell_123$"
$tejasFQDN = "tejas1137.mydomain.com"
$SccmSmBiosGuid ="5SXDW22,5SXDW22,MINWINPC,PowerEdge\n\rR730,44454c4c-5300-1058-8044-b5c04f573232,4c4c4544-0053-5810-8044-b5c04f573232,B8:2A:72:D5:B1:0B?B8:2A:72:D5:B1:0C?B8:2A:72:D5:B1:09?B8:2A:72:D5:B1:0A?,255.255.255.128,Microsoft\n\rWindows\n\rServer\n\r2016:Microsoft\n\rWindows\n\rServer\n\r2012:Microsoft\n\rWindows\n\rServer\n\r2012\n\rR2:Red\n\rHat\n\rEnterprise\n\rLinux\n\r6.8\n\rx64:Red\n\rHat\n\rEnterprise\n\rLinux\n\r7.2\n\rx64:SuSE\n\rEnterprise\n\rLinux\n\r11\n\rSP4\n\rx64:SuSE\n\rEnterprise\n\rLinux\n\r12\n\rSP1\n\rx64:VMware\n\rESXi:Xen\n\rServer:,16.10.10,100.96.34.140"
#>

Function Createcredobj($username, $passwd){
    try{
		$secpasswd = ConvertTo-SecureString  $passwd -AsPlainText -Force
        $mycredsobj = New-Object System.Management.Automation.PSCredential ($username, $secpasswd)
        #$Error
    }
    catch{
        $mycredsobj = $null
    }

    return $mycredsobj
}



$SccmSmBiosGuid = $SccmSmBiosGuid -replace "\\n\\r", " "


$returnval = @()


$sccmCred= Createcredobj $DomainUsername $DelPwd

try{
    #step 0. Create connection with SCCM machine and get the site code
    $siteCode=Invoke-Command -ComputerName $ComputerName -Credential $sccmCred -ConfigurationName Microsoft.PowerShell32 -ScriptBlock{
            Import-Module -Name "$(split-path $Env:SMS_ADMIN_UI_PATH)\ConfigurationManager.psd1"
	   	    $PSD = Get-PSDrive -PSProvider CMSite
	        if($PSD -eq $null){
			    New-PSDrive -Name "LOCAL" -PSProvider CMSite -Root $args[0]
			    $PSDN = Get-PSDrive -PSProvider CMSite -Name "LOCAL"
			    $SiteCode= CD "$($PSDN):"
		    }else{
	            $SiteCode= CD "$($PSD):"	
		    }
	        $VMMobj= Get-CMSite
            if ( $VMMobj -ne $null ){
			
			    return $VMMobj.SiteCode
	        }else{
			    return "Site Code of the SC was not identified"
		    }
    }-Args $ComputerName -ErrorVariable errmsg  2>$null
	#step 1. Create connection with SCCM machine and get the site code
	$emsg=Invoke-Command -ComputerName $ComputerName -Credential $sccmCred -ConfigurationName Microsoft.PowerShell32 -ScriptBlock{
    
   	
		############### CONSTANTS ###########################
		
		set-variable -name Response_Success -value "SUCCESS" -option constant
		set-variable -name Response_FAIL -value "FAIL" -option constant
		set-variable -name Exception_Code -value 101 -option constant
		set-variable -name zeroguid -value "00000004-0000-0000-0000-000000000000" -option constant
		set-variable -name collectionNameAllSystems -value "All Systems" -option constant
		set-variable -name osNameVersionIndex -value "0,1,2,3,4,5,6,7,8,9" -option constant
		set-variable -name collectionNameImportDellServers -value "Dell Imported Servers" -option constant
		set-variable -name collectionNameAllDellLCControllers -value "All Dell Lifecycle Controller Servers" -option constant
		set-variable -name collectionCommentImportDellServers -value "All Dell PowerEdge servers discovered using Import Dell PowerEdge servers wizard" -option constant
		set-variable -name collectionCommentAllDellLCControllers -value "All Dell PowerEdge servers" -option constant
		set-variable -name collectionNameRhel -value "managed dell lifecycle controller(rhel)" -option constant
		set-variable -name collectionNameEsxi -value "managed dell lifecycle controller(esxi)" -option constant
		set-variable -name osRhel -value "rhel" -option constant
		set-variable -name osEsxi -value "esxi" -option constant
		set-variable -name collectionCommentAllDellLCControllers -value "All Dell PowerEdge servers" -option constant
		set-variable -name collectionNameOSDeployed -value "Managed Dell Lifecycle Controller(Windows OS Deployed)" -option constant
		set-variable -name collectionNameOSUnknown -value  "Managed Dell Lifecycle Controller(OS Unknown)" -option constant
		set-variable -name collectionCommentOSDeployed -value "All Dell PowerEdge 11G (and above) servers with Configuration Manager Client" -option constant
		set-variable -name collectionCommentOSUnknown -value "All Dell PowerEdge 11G (and above) servers without Configuration Manager Client"-option constant
		
		############### CONSTANTS ###########################
		
		function Write-Log
        {
            param (
                [Parameter(Mandatory)]
                [string]$Message,
        
                [Parameter()]
                [ValidateSet('1','2','3')]
                [int]$Severity = 1 ## Default to a low severity. Otherwise, override
            )
    
            $line = [pscustomobject]@{
                'DateTime' = (Get-Date -Format "yyyy-MM-dd HH:mm:ss:ffff")
                'Message' = $Message
            }
    
            ## Ensure that $LogFilePath is set to a global variable at the top of script
            $line | Export-Csv -Path $LogFilePath -Append -NoTypeInformation
        }

        $logBasePath="$(split-path $Env:SMS_ADMIN_UI_PATH)";
        $logFilePath="OMIMSSC_Discovery.log"

        $global:LogFilePath = Join-Path $logBasePath $logFilePath

       try{

        if (!(Test-Path $LogFilePath)) {
            
            $NewLogFile = New-Item $LogFilePath -Force -ItemType File
          }

        else {
            # Nothing to see here yet.
            }
         }catch{
            $tempPath =[System.IO.Path]::GetTempPath()
            $basePath = [io.path]::combine($tempPath + "Log")
            $logFile=  Join-Path $basePath  $logFilePath 
            [system.io.directory]::CreateDirectory($logFile)
            $LogFilePath=$logFile
         }
        
		Write-Log -Message "--------------------------------------------------------------------------------------"
        Write-Log -Message "--------------------------------------------------------------------------------------"
		Write-Log -Message "Auto Discovery of Server in SCCM Started"
        Write-Log -Message "--------------------------------------------------------------------------------------"
        Write-Log -Message "--------------------------------------------------------------------------------------"
		
        $site=$args[3]
		#Step 2. Split the smbios to get the machine information
		$nodeId=$args[2].split(",")[0]
		$serviceTag=$args[2].split(",")[1]
		$hostname=$args[2].split(",")[2]
		$model=$args[2].split(",")[3]
		$guid=$args[2].split(",")[4]
		$platformGuid=$args[2].split(",")[5]
		$macAddress=$args[2].split(",")[6].split("?")
		$ipsubnet=$args[2].split(",")[7]
		$osnames=$args[2].split(",")[8].split(":")
		$driverpackversion=$args[2].split(",")[9]
		$ipaddresses=$args[2].split(",")[10]
		
		$nonWindowsOSDeployed=""
		
		#Step 3. Get the custom Collection Query id 
		[System.Guid] $guidObject = [System.Guid]::NewGuid()
		$customcollectionqueryid="dell_"+$guidObject.Guid
		
		$tempHostName=$hostname
		
		#Step 4. Find if the host exists
		$query="Select NETBIOSNAME from SMS_R_System where SMBIOSGUID='$guid'"
		$ns="root\sms\site_$site"
		
		$responses=Get-WMIObject -Query $query -Namespace $ns
        
		if(![string]::IsNullOrEmpty($guid) -or $guid -ne $zeroguid){
			
               if($responses -ne $null){
				    #we found the host from sms_r_system
				    foreach($response in $responses){
					    $hostname=$response.NETBIOSNAME
				    }
                    Write-Log -Message "System is present in SMS_R_SYSTEM using SMBIOSGUID"
			   }
            else{
			    $hostname=""
		    }
		}
        
		
		#Step 5. if the hostname was not found in sms_r_system then check if any row is available for temphostname
		
		if([string]::IsNullorEmpty($hostname)){
			$query="Select * from SMS_R_System where NETBIOSNAME='$tempHostName'"
			$responses=Get-WMIObject -Query $query -Namespace $ns
			
                    
			if($responses -ne $null){
				$hostname=$tempHostName
				
			}else{
				
				#Step 6. If the host occurence is not found in sms_r_system, then check if macadress is present in sms_r_system. 
				
				$hostname=""
				foreach($macadd in $macAddress){
					$query="Select NETBIOSNAME from SMS_R_SYSTEM where MACAddresses='$macadd'"
					$responses=Get-WMIObject -Query $query -Namespace $ns
					
					if($responses -ne $null){
						foreach($response in $responses){
							if(![string]::IsNullorEmpty($response.NETBIOSNAME)){
								$hostname=$response.NETBIOSNAME
                                Write-Log -Message "System is present in SMS_R_SYSTEM using MACAddresses"
							}
						}
					}
				}
				
				if([string]::IsNullorEmpty($hostname)){
					$hostname=$serviceTag
				}
			}
			
		}
		#Step 7. Delete the old DDR
		#Start deleting the old DDR
        Write-Log -Message "Delete the old reference of system from iDRAC, if any"
		$queryDelIdrac="Select resourceID from SMS_R_iDRAC where SMBIOSGUID = '$guid'"
		$queryResultsforIdracs=Get-WMIObject -Query $queryDelIdrac -Namespace $ns
	
           
		if($queryResultsforIdracs -ne $null){
			foreach($queryResultforIdrac in $queryResultsforIdracs){
			
				$resourceID=$queryResultforIdrac.resourceID
			    $comp=$queryResultforIdrac
				$comp.psbase.delete()
			}
		}
		Write-Log -Message "Delete the old reference of system from System, if any"
		$queryDelSystem="Select resourceID from SMS_R_System WHERE SMBIOSGUID = '$guid'"
		$queryResultsforSystems=Get-WMIObject -Query $queryDelSystem -Namespace $ns
				
		if($queryResultsforSystems -ne $null){
			foreach($queryResultforSystem in $queryResultsforSystems){
				$comp=$queryResultforSystem
				$comp.psbase.delete()
			}
		}
		#Finished deleting the old DDR
		
		#Step 8. Import Machine Entry
		###Start Create New DDR For Import  Dell Servers
		Write-Log -Message "Calling ImportMachineEntry Method"
		#Ensure that DHS passed in at least one IP address
		if($ipaddresses.Count -gt 0){
			$EmptyQueryResult=$true
		
			#Create new hosts for Import Dell Servers
			if($macAddress -ne $null -and $macAddress.Count -gt 0){
				$WMIConnection = ([WMIClass]"\\.\root\SMS\Site_$($site):SMS_Site")
	    
				$NewEntry = $WMIConnection.psbase.GetMethodParameters("ImportMachineEntry")
				
				$NewEntry.NetbiosName=$hostName
				$NewEntry.SMBIOSGUID=$guid
				$NewEntry.MACAddress =$macAddress[0]
				$NewEntry.OverwriteExistingRecord=$true
				
				$ImportMachineEntryResponse = $WMIConnection.psbase.InvokeMethod("ImportMachineEntry",$NewEntry,$null)
                   #$ImportMachineEntryResponse=Invoke-WmiMethod -class \\SCCMSHARU1\ROOT\sms\site_101:SMS_Site -Name ImportMachineEntry -InputObject $NewEntry -Impersonation Impersonate
	            Write-Log -Message "Executed ImportMachineEntry Method"
	
                   #####ACTION TO CHANGE ####### CHANGE eq TO ne
                   if($ImportMachineEntryResponse -ne $null){
					#Step 9. Create DDRs
					#modify host using DDR For Import Dell Servers
					$queryString="SELECT * from SMS_R_System WHERE NetbiosName='$hostname'"
					$queryResult=Get-WMIObject -Query $queryString -Namespace $ns
					$resourceNames=@('Dell iDRAC')
                    $EmptyQueryResult=$true  
					if($queryResult -ne $null){
						$EmptyQueryResult=$false
					    Write-Log -Message "Created ImportMachineEntry Method"
						foreach($res in $queryResult){
                               
							Write-Log -Message "Modify host using DDR For Import Dell Servers"
							Try {
									$messagePATH =(Get-ItemProperty -Path 'HKLM:\SOFTWARE\WOW6432Node\Microsoft\SMS\Deployment\Dell\DLCI' -Name "Installation Directory")."Installation Directory"
									write-host "Installtion Path: " $messagePATH
							}
							Catch [System.Management.Automation.PSArgumentException]
							{}													
							#new approach to create the DDR
							$messageDLLFullPath= join-path $messagePATH "Microsoft.ConfigurationManagement.Messaging.dll"
							Add-Type -Path $messageDLLFullPath
							$key=[Microsoft.ConfigurationManagement.Messaging.Messages.Server.DdmDiscoveryFlags]::Key
							$array=[Microsoft.ConfigurationManagement.Messaging.Messages.Server.DdmDiscoveryFlags]::Array
							$none=[Microsoft.ConfigurationManagement.Messaging.Messages.Server.DdmDiscoveryFlags]::None
                            $name=[Microsoft.ConfigurationManagement.Messaging.Messages.Server.DdmDiscoveryFlags]::Name
							$name2=[Microsoft.ConfigurationManagement.Messaging.Messages.Server.DdmDiscoveryFlags]::NameDescription
							
							$ddrFile=new-object -TypeName Microsoft.ConfigurationManagement.Messaging.Messages.Server.DiscoveryDataRecordFile("customAgent")

							$ddrFile.Architecture='System'
							$ddrFile.SiteCode=$site
							
							$ddrFile.AddStringProperty("Netbios Name",$key,64,$hostname)
							$ddrFile.AddStringPropertyArray("MAC Addresses",$array,64,$macAddress)
							
							Write-Log -Message "Get the DDR Path from WMI"
							$ddrInboxPath=""
							$getDDRQuery="SELECT DDRPath from SMS_Dell_OOBConfig_Settings WHERE ResourceID=1"
							$resultsGetDDR=Get-WMIObject -Query $getDDRQuery -Namespace "root\cimv2\dlci"
	    
        
							if($resultsGetDDR -ne $null){
								foreach($resultGetDDR in $resultsGetDDR){
									$ddrInboxPath=$resultGetDDR.DDRPath
								}
							}
	    
							if($ddrInboxPath.Length -eq 0){
								#sccmDDRPath = Microsoft.ConfigurationManagement.IntegrationDevelopmentKit.IntegrationKitUtilities.GetConfigMgrRegistryStringValue("Identification", "Installation Directory");
								# sccmDDRPath += "\\inboxes\\auth\\ddm.box\\{0}";
								$ddrInboxPath =$ddrInboxPath+ "\\{0}"
							}
							 
                            $fileddrPath= join-path $ddrInboxPath "$hostname.DDR"
							$msg= "DDR Path is: " + $fileddrPath
                            Write-Log -Message $msg

							
							Write-Log -Message "Save the DDR to the Path"
							#$wasDDRCreated=$SMSDisc.DDRWrite($desktopPath)
							$tmp=[System.IO.Path]::GetTempPath()
							$tempDDR=$ddrFile.SerializeToFile($tmp)
						    #write-host "tempDDR: " + $tempDDR
							
							if([string]::IsNullorEmpty($tempDDR)){
								Write-Log -Message "Message:Failed to create SYSTEM DDR"
								return "State:$response_FAIL,Message:Failed to create SYSTEM DDR"
							}else{
								#validating the path returned from $tempDDR
								#test if the file exists
								if(Test-Path $tempDDR){
									#check the size of file
									if((Get-Item $tempDDR).Length -eq '0'){
                                        Write-Log -Message "Message:Empty SYSTEM DDR created"
										return "State:$response_FAIL,Message:Empty SYSTEM DDR created"
									}
								}else{
                                    Write-Log -Message "Message:Failed to create SYSTEM DDR"
									return "State:$response_FAIL,Message:Failed to create SYSTEM DDR"
								}
							}
        
                            #now copy this DDR file to your SCCM Server DDM.Box inbox 
                            Copy-Item -path $tempDDR -Destination $fileddrPath
                            Write-Log -Message "Copy the DDR file to your SCCM Server DDM.Box inbox"								
                            if(Test-Path $tempDDR){	
								[System.IO.File]::Delete($tempDDR)
							}
							Write-Log -Message "Delete the DDR file"
							
							#Create DDR for idrac
							Write-Log -Message "Create DDR for idrac in SCCM"
							$ddrFile2=new-object -TypeName Microsoft.ConfigurationManagement.Messaging.Messages.Server.DiscoveryDataRecordFile("customAgent")
							
							$ddrFile2.SiteCode=$site
							$ddrFile2.Architecture='iDRAC'
							$ddrFile2.Trusted="true"
							$ddrFile2.IsSigned="true"
							
							$ddrFile2.AddStringProperty("Netbios Name",$name,64,$hostname)
						    $ddrFile2.AddStringProperty("ProvisioningMethod",$name,64,"Auto Discovered")
						    $ddrFile2.AddStringProperty("Computer Name",$none,64,$hostname)
                            if([string]::IsNullOrEmpty($serviceTag)){
                                  $serviceTag="";
                            }
						    $ddrFile2.AddStringProperty("Service Tag",$none,64,$serviceTag)
						    $ddrFile2.AddStringProperty("Node ID",$none,64,$nodeId)
                            $ddrFile2.AddStringPropertyArray("Resource Names",$none,64,$resourceNames)
						    $ddrFile2.AddStringProperty("Description",$name2,64,"Dell iDRAC")
					        $ddrFile2.AddStringProperty("IP Addresses",$none,64,$ipaddresses)
                            if (![string]::IsNullOrEmpty($guid))
                            {
                                  $ddrFile2.AddStringProperty("SMBIOS GUID",$none,64,$guid)
                            }
                            if (![string]::IsNullOrEmpty($model))
                            {
                                  $ddrFile2.AddStringProperty("Model",$none,64,$model)
                            }
                            $ddrFile2.AddStringProperty("CustomCollectionName",$none,64,$customcollectionqueryid)
                            if (![string]::IsNullOrEmpty($ipsubnet))
                            {
                                  $ddrFile2.AddStringProperty("IP Subnets",$none,64,$ipsubnet)
                            }

                            if($macAddress -eq $null -or $macAddress.Length -eq 0){
							
						    }
                            else
                            {
                                 $ddrFile2.AddStringPropertyArray("MAC Addresses",$array,64,$macAddress)
                            }

						    if($nonWindowsOSDeployed.ToLower() -match $osRhel -or $nonWindowsOSDeployed.ToLower() -match $osEsxi){
								    #$SMSDisc.DDRAddString("OSName", $nonWindowsOSDeployed, 64, 0x8)
                                    $ddrFile2.AddStringProperty("OSName",$name2,64,$nonWindowsOSDeployed) 
						    }
                            else
                            {
								    #$SMSDisc.DDRAddString("OSName", "", 64, 0x8)
								    $ddrFile2.AddStringProperty("OSName",$name2,64,"")
						    }
							
						    if($osnames -eq $null -or $osnames.Length -eq 0){
							
								    #$SMSDisc.DDRAddString("Driver Pack Version", "Unknown", 64, 0x8)
								    $ddrFile2.AddStringProperty("Drivers Available For",$none,64,"Unknown")
								
						    }
                            else
                            {
								    #$SMSDisc.DDRAddString("Drivers Available For", $osnames, 64, 0x8)
								    $ddrFile2.AddStringPropertyArray("Drivers Available For",$array,64,$osnames)
								    if([string]::IsNullOrEmpty($driverpackversion)){
									    #$SMSDisc.DDRAddString("Driver Pack Version", "Unknown", 64, 0x8)
									    $ddrFile2.AddStringProperty("Driver Pack Version",$none,64,"Unknown")
									
						            }
                                    else
                                    {
									     #$SMSDisc.DDRAddString("Driver Pack Version", $driverpackversion, 64, 0x8)
									     $ddrFile2.AddStringProperty("Driver Pack Version",$none,64,$driverpackversion)
						            }
						    }
							
							$idracOutDdrName= "Idrac-"+$hostname+".DDR"
        
        
                            $fileddrPath= join-path $ddrInboxPath $idracOutDdrName
                            $msg= "DDR Path is: " + $fileddrPath
                            Write-Log -Message $msg													
							Write-Log -Message "Save the DDR to the Path"
							#$wassecondddr=$SMSDisc.DDRWrite($desktopPath)
							$tmp=[System.IO.Path]::GetTempPath()
							$tempDDR=$ddrFile2.SerializeToFile($tmp)
							#write-host "tempDDR2: " + $tempDDR
							if([string]::IsNullorEmpty($tempDDR)){
                                    Write-Log -Message "Message:Failed to create iDRAC DDR"
									return "State:$response_FAIL,Message:Failed to create iDRAC DDR"
							}else{
								#validating the path returned from $tempDDR
								#test if the file exists
								if(Test-Path $tempDDR){
									#check the size of file
									if((Get-Item $tempDDR).Length -eq '0'){
                                        Write-Log -Message "Message:Empty iDRAC DDR created"
										return "State:$response_FAIL,Message:Empty iDRAC DDR created"
									}
								}else{
                                    Write-Log -Message "Message:Failed to create iDRAC DDR"
									return "State:$response_FAIL,Message:Failed to create iDRAC DDR"
								}
							}
							
                            Write-Log -Message "copy this DDR file to your SCCM Server DDM.Box inbox"  
                            Copy-Item -path $tempDDR -Destination $fileddrPath

                            if(Test-Path $tempDDR){	
								[System.IO.File]::Delete($tempDDR)
							}
                            Write-Log -Message "Delete the DDR"
						}
					}
					if($EmptyQueryResult){
						Write-Log -Message "If we reach here then it means that the ImportMachineEntry SCCM call did not add the system with 
						this Netbiosname. One of the reason is because the system with the same SMBIOSGUID already exists  
						in SMS_R_SYSTEM with a different hostname"
						
						#Since an entry is in SCCM with hostname (other than svctag), create iDRAC DDR and copy to ddm box
						#create the COM Object
						#$SMSDisc = New-Object -ComObject SMSResGen.SMSResGen.1
						
						Try {
									$messagePATH =(Get-ItemProperty -Path 'HKLM:\SOFTWARE\WOW6432Node\Microsoft\SMS\Deployment\Dell\DLCI' -Name "Installation Directory")."Installation Directory"
									write-host "Installtion Path: " $messagePATH
						}
						Catch [System.Management.Automation.PSArgumentException]
						{}													
						#new approach to create the DDR
						$messageDLLFullPath= join-path $messagePATH "Microsoft.ConfigurationManagement.Messaging.dll"
						Add-Type -Path $messageDLLFullPath		
						$key=[Microsoft.ConfigurationManagement.Messaging.Messages.Server.DdmDiscoveryFlags]::Key
						$array=[Microsoft.ConfigurationManagement.Messaging.Messages.Server.DdmDiscoveryFlags]::Array
						$none=[Microsoft.ConfigurationManagement.Messaging.Messages.Server.DdmDiscoveryFlags]::None
						
						
						
						Write-Log -Message "Create DDR for idrac"
						$ddrFile2=new-object -TypeName Microsoft.ConfigurationManagement.Messaging.Messages.Server.DiscoveryDataRecordFile("customAgent")
						
						$ddrFile2.SiteCode=$site
						$ddrFile2.Architecture='iDRAC'
						$ddrFile2.Trusted="true"
						$ddrFile2.IsSigned="true"
						
						$ddrFile2.AddStringProperty("Netbios Name",$name,64,$hostname)
						$ddrFile2.AddStringProperty("ProvisioningMethod",$name,64,"Auto Discovered")
						$ddrFile2.AddStringProperty("Computer Name",$none,64,$hostname)
                        if([string]::IsNullOrEmpty($serviceTag)){
                              $serviceTag="";
                        }
						$ddrFile2.AddStringProperty("Service Tag",$none,64,$serviceTag)
						$ddrFile2.AddStringProperty("Node ID",$none,64,$nodeId)
                        $ddrFile2.AddStringPropertyArray("Resource Names",$none,64,$resourceNames)
						$ddrFile2.AddStringProperty("Description",$name2,64,"Dell iDRAC")
					    $ddrFile2.AddStringProperty("IP Addresses",$none,64,$ipaddresses)
                        if (![string]::IsNullOrEmpty($guid))
                        {
                              $ddrFile2.AddStringProperty("SMBIOS GUID",$none,64,$guid)
                        }
                        if (![string]::IsNullOrEmpty($model))
                        {
                              $ddrFile2.AddStringProperty("Model",$none,64,$model)
                        }
                        $ddrFile2.AddStringProperty("CustomCollectionName",$none,64,$customcollectionqueryid)
                        if (![string]::IsNullOrEmpty($ipsubnet))
                        {
                              $ddrFile2.AddStringProperty("IP Subnets",$none,64,$ipsubnet)
                        }

                        if($macAddress -eq $null -or $macAddress.Length -eq 0){
							
						}
                        else
                        {
                             $ddrFile2.AddStringPropertyArray("MAC Addresses",$array,64,$macAddress)
                        }

						if($nonWindowsOSDeployed.ToLower() -match $osRhel -or $nonWindowsOSDeployed.ToLower() -match $osEsxi){
								#$SMSDisc.DDRAddString("OSName", $nonWindowsOSDeployed, 64, 0x8)
                                $ddrFile2.AddStringProperty("OSName",$name2,64,$nonWindowsOSDeployed) 
						}
                        else
                        {
								#$SMSDisc.DDRAddString("OSName", "", 64, 0x8)
								$ddrFile2.AddStringProperty("OSName",$name2,64,"")
						}
							
						if($osnames -eq $null -or $osnames.Length -eq 0){
							
								#$SMSDisc.DDRAddString("Driver Pack Version", "Unknown", 64, 0x8)
								$ddrFile2.AddStringProperty("Drivers Available For",$none,64,"Unknown")
								
						}
                        else
                        {
								#$SMSDisc.DDRAddString("Drivers Available For", $osnames, 64, 0x8)
								$ddrFile2.AddStringPropertyArray("Drivers Available For",$array,64,$osnames)
								if([string]::IsNullOrEmpty($driverpackversion)){
									#$SMSDisc.DDRAddString("Driver Pack Version", "Unknown", 64, 0x8)
									$ddrFile2.AddStringProperty("Driver Pack Version",$none,64,"Unknown")
									
						        }
                                else
                                {
									 #$SMSDisc.DDRAddString("Driver Pack Version", $driverpackversion, 64, 0x8)
									 $ddrFile2.AddStringProperty("Driver Pack Version",$none,64,$driverpackversion)
						        }
						}
							
							
						Write-Log -Message "Get the DDR Path from WMI"
						$ddrInboxPath=""
						$getDDRQuery="SELECT DDRPath from SMS_Dell_OOBConfig_Settings WHERE ResourceID=1"
						$resultsGetDDR=Get-WMIObject -Query $getDDRQuery -Namespace "root\cimv2\dlci"
	                    
                        
						if($resultsGetDDR -ne $null){
							foreach($resultGetDDR in $resultsGetDDR){
								$ddrInboxPath=$resultGetDDR.DDRPath
							}
						}
	                    
						if($ddrInboxPath.Length -eq 0){
							$ddrInboxPath =$ddrInboxPath+ "\\{0}"
						}
						$idracOutDdrName= "Idrac-"+$hostname+".DDR"
						$desktopPath="C:\$idracOutDdrName"
	           						
                        $fileddrPath= join-path $ddrInboxPath $idracOutDdrName
						
                        Write-Log -Message $msg
						Write-Log -Message "Save the DDR to the Path"	
						$tmp=[System.IO.Path]::GetTempPath()
						$tempDDR=$ddrFile2.SerializeToFile($tmp)
						
						#$wassecondddr=$SMSDisc.DDRWrite($desktopPath)
						#$SMSDisc.DDRWrite($fileddrPath)
                        
						if([string]::IsNullorEmpty($tempDDR)){
                            Write-Log -Message "Message:Failed to create iDRAC DDR"
							return "State:$response_FAIL,Message:Failed to create iDRAC DDR"
						}else{
							#validating the path returned from $tempDDR
							#test if the file exists
							if(Test-Path $tempDDR){
								#check the size of file
								if((Get-Item $tempDDR).Length -eq '0'){
                                    Write-Log -Message "Message:Empty iDRAC DDR created"
									return "State:$response_FAIL,Message:Empty iDRAC DDR created"
								}
                                
							}else{
                                Write-Log -Message "Message:Failed to create iDRAC DDR"
								return "State:$response_FAIL,Message:Failed to create iDRAC DDR"
							}
						}
						
                        Write-Log -Message "Copy this DDR file to your SCCM Server DDM.Box inbox"
                        Copy-Item -path $tempDDR -Destination $fileddrPath
						if(Test-Path $tempDDR){	
								[System.IO.File]::Delete($tempDDR)
						}
                        Write-Log -Message "Delete the DDR"
					}
					
				}
			}
		
			Write-Log -Message "Initiate Collection Creation"
			#Step 11. Create Dell Collections
			#check if Collection $collectionNameAllDellLCControllers exists or not
			$retCode=$false	
			Write-Log -Message "Check if the collection All Dell LC Controllers exist"
			$collName=$collectionNameAllDellLCControllers
			
			$collName=$collName.Replace("\","\\")
			$collName=$collName.Replace("'","\'")
			
			$queryString="Select * from SMS_Collection WHERE Name='$collName'"
			$collResult=Get-WMIObject -Query $queryString -Namespace $ns
			
			if($collResult -ne $null ){
					
				foreach($row in $collResult){
					$parentColl=$row.CollectionId
				}
				
				if(![string]::IsNullorEmpty($parentColl)){
					Write-Log -Message "check if the collection Managed Dell Lifecycle Controller (OS Unknown) exists"
					$collExist=$false
					$query="Select * from SMS_Collection WHERE Name='$collectionNameOSUnknown'"
					$result = Get-WMIObject -query $query -namespace $ns
					
					if($result -ne $null){
						$collExist=$true
					}
					
					if(!$collExist){
						Write-Log -Message "create new SMS_Collection object"
						$CMCollection = ([WMIClass]"\\.\root\SMS\Site_$($site):SMS_Collection").CreateInstance()
						$CMCollection.Name=$collectionNameOSUnknown
						$CMCollection.Comment=$collectionCommentOSUnknown
						$CMCollection.OwnedByThisSite=$true
						$CMCollection.LimitToCollectionID=$parentColl
						$CMCollection.Put() 
						$CMCollection.Get()
						
						$validateQuery="Select * from SMS_R_SYSTEM Inner join SMS_R_iDRAC ON  (SMS_R_SYSTEM.SMBIOSGUID=SMS_R_iDRAC.SMBIOSGUID OR SMS_R_SYSTEM.NETBIOSNAME=SMS_R_iDRAC.NETBIOSNAME) WHERE SMS_R_SYSTEM.Client=0"
						$ruleName="11G_No_OS_Rule"
						
						$ValidatingQuery = Invoke-WmiMethod -Namespace $ns -Class SMS_CollectionRuleQuery -Name ValidateQuery -ArgumentList $validateQuery
						if($ValidatingQuery -eq $null){
                            Write-Log -Message "Message:Validation of query failed"
							return "Status:$response_FAIL,Message:Validation of query failed"
						}
						
						Write-Log -Message "Create new Query Rule"
						$NewRule = ([WMIClass]"\\.\Root\SMS\Site_$($site):SMS_CollectionRuleQuery").CreateInstance()
						$NewRule.QueryExpression=$validateQuery
						$NewRule.RuleName=$ruleName
						
	
						$CMCollection.CollectionRules    += $NewRule.psobject.baseobject
						$put                     		 = $CMCollection.Put()
                        $refresh                         = $CMCollection.RequestRefresh()
                        $retCode=$true
						
						
					}
					
					Write-Log -Message "Check if the Collection Managed Dell Lifecycle Controller (OS Deployed) is present"
					$collExist=$false
					$query="Select * from SMS_Collection WHERE Name='$collectionNameOSDeployed'"
					$result = Get-WMIObject -query $query -namespace $ns
					
					if($result -ne $null){
						$collExist=$true
					}
					
					if(!$collExist){
						Write-Log -Message "Create new SMS_Collection object"
						$CMCollection = ([WMIClass]"\\.\root\SMS\Site_$($site):SMS_Collection").CreateInstance()
						$CMCollection.Name=$collectionNameOSDeployed
						$CMCollection.Comment=$collectionCommentOSDeployed
						$CMCollection.OwnedByThisSite=$true
						$CMCollection.LimitToCollectionID=$parentColl
						$CMCollection.Put()
						$CMCollection.Get()
						
						$validateQuery="Select * from SMS_R_SYSTEM Inner join SMS_R_iDRAC ON  (SMS_R_SYSTEM.SMBIOSGUID=SMS_R_iDRAC.SMBIOSGUID OR SMS_R_SYSTEM.NETBIOSNAME=SMS_R_iDRAC.NETBIOSNAME) WHERE SMS_R_SYSTEM.Client=1"
						$ruleName="11G_OS_Rule"
						
						$ValidatingQuery = Invoke-WmiMethod -Namespace $ns -Class SMS_CollectionRuleQuery -Name ValidateQuery -ArgumentList $validateQuery
						if($ValidatingQuery -eq $null){
							return "Status:$response_FAIL,Message:Validation of query failed"
						}
						
						Write-Log -Message "Create new Query Rule"
						$NewRule = ([WMIClass]"\\.\Root\SMS\Site_$($site):SMS_CollectionRuleQuery").CreateInstance()
						$NewRule.QueryExpression=$validateQuery
						$NewRule.RuleName=$ruleName
						
	
						$CMCollection.CollectionRules    += $NewRule.psobject.baseobject
						$put                     		 = $CMCollection.Put()
                        $refresh                         = $CMCollection.RequestRefresh()
                        $retCode=$true					
					}
				}
			}else{
				Write-Log -Message "The collection collectionName All Dell LC Controllers does not exist"
				
				$retCode = $false
				$parentColl = ""
				$queryString = "Select * from SMS_R_iDRAC"
				$collFound = $false
				$MAXRETRIES = 1
				$ctr = 0
		
		
				while($ctr -lt $MAXRETRIES -and $collFound -eq $false){ 
					$ctr=$ctr+1
				
					$result=Get-WMIObject -Query $queryString -Namespace $ns
				
				
					if($result -ne $null)
					{
						$collFound = $true
					}
				

					Write-Log -Message "Create the Collcetion Dell Lifecycle Controllers"
					$limitToCollectionID="SMS00001"
					$ownedByThisSite=$true
					$query="Select * from SMS_R_SYSTEM Inner join SMS_R_iDRAC ON (SMS_R_SYSTEM.SMBIOSGUID=SMS_R_iDRAC.SMBIOSGUID OR SMS_R_SYSTEM.NETBIOSNAME=SMS_R_iDRAC.NETBIOSNAME)"
					$ruleName= "11G_Parent_Rule"
					$validateQuery=$true
					
					Write-Log -Message "Create new SMS_Collection object"
					$CMCollection = ([WMIClass]"\\.\root\SMS\Site_$($site):SMS_Collection").CreateInstance()
					$CMCollection.Name=$collectionNameAllDellLCControllers
					$CMCollection.Comment=$collectionCommentAllDellLCControllers
					$CMCollection.OwnedByThisSite=$ownedByThisSite
					$CMCollection.LimitToCollectionID=$limitToCollectionID
					$didCommit=$CMCollection.Put()
					$CMCollection.Get()


		
					#validate
					if($validateQuery -eq $true){
						Write-Log -Message "Validate Query syntax"  
						$ValidatingQuery = Invoke-WmiMethod -Namespace $ns -Class SMS_CollectionRuleQuery -Name ValidateQuery -ArgumentList $query
						if($ValidatingQuery -eq $null){
							return "Status:$response_FAIL,Message:Validation of query failed"
						}
					}
					
					Write-Log -Message "Create new Query Rule"
					$NewRule = ([WMIClass]"\\.\Root\SMS\Site_$($site):SMS_CollectionRuleQuery").CreateInstance()
					$NewRule.QueryExpression=$query
					$NewRule.RuleName=$ruleName
					

					$CMCollection.CollectionRules    += $NewRule.psobject.baseobject
                    $put                             = $CMCollection.Put()
                    $refresh                         = $CMCollection.RequestRefresh()
                    $retCode=$true


					
					if($retCode -eq $true){
						#get Collection ID
						$queryCollectionId="Select CollectionID from SMS_Collection WHERE Name='$collectionNameAllDellLCControllers'"
						$collectionID=Get-WMIObject -Query $queryCollectionId -Namespace $ns
						

						if($collectionId -eq $null){
                            Write-Log -Message "Unable to retrieve collection ID for Name='$collectionNameAllDellLCControllers'"
							return "Unable to retrieve collection ID for collectionName All Dell LC Controllers"
						}else{
							foreach($id in $collectionId){
								$parentColl=$id.CollectionID
							}
						}
						

						if(![string]::IsNullOrEmpty($parentColl)){
							Write-Log -Message "Check if the collection Managed Dell Lifecycle Controller (OS Unknown) exists"
							$collExist=$false
							$query="Select * from SMS_Collection WHERE Name='$collectionNameOSUnknown'"
							$result = Get-WMIObject -query $query -namespace $ns
							
							if($result -ne $null){
								$collExist=$true
							}
							
							if(!$collExist){
								Write-Log -Message "Create new SMS_Collection object"
								$CMCollection = ([WMIClass]"\\.\root\SMS\Site_$($site):SMS_Collection").CreateInstance()
								$CMCollection.Name=$collectionNameOSUnknown
								$CMCollection.Comment=$collectionCommentOSUnknown
								$CMCollection.OwnedByThisSite=$true
								$CMCollection.LimitToCollectionID=$parentColl
								$CMCollection.Put()
								$CMCollection.Get()
								
								$validateQuery="Select * from SMS_R_SYSTEM Inner join SMS_R_iDRAC ON  (SMS_R_SYSTEM.SMBIOSGUID=SMS_R_iDRAC.SMBIOSGUID OR SMS_R_SYSTEM.NETBIOSNAME=SMS_R_iDRAC.NETBIOSNAME) WHERE SMS_R_SYSTEM.Client=0"
								$ruleName="11G_No_OS_Rule"
								
								$ValidatingQuery = Invoke-WmiMethod -Namespace $ns -Class SMS_CollectionRuleQuery -Name ValidateQuery -ArgumentList $validateQuery
								if($ValidatingQuery -eq $null){
									return "Status:$response_FAIL,Message:Validation of query failed"
								}
								
								Write-Log -Message "Create new Query Rule"
								$NewRule = ([WMIClass]"\\.\Root\SMS\Site_$($site):SMS_CollectionRuleQuery").CreateInstance()
								$NewRule.QueryExpression=$validateQuery
								$NewRule.RuleName=$ruleName
								
			
								$CMCollection.CollectionRules    += $NewRule.psobject.baseobject
								$put                             = $CMCollection.Put()
								$refresh                         = $CMCollection.RequestRefresh()
								$retCode=$true
									
								}
							
							Write-Log -Message "Check if the Collection Managed Dell Lifecycle Controller (OS Deployed) is present"
							$collExist=$false
							$query="Select * from SMS_Collection WHERE Name='$collectionNameOSDeployed'"
							$result = Get-WMIObject -query $query -namespace $ns
							
							if($result -ne $null){
								$collExist=$true
							}
							
							if(!$collExist){
								Write-Log -Message "create new SMS_Collection object"
								$CMCollection = ([WMIClass]"\\.\root\SMS\Site_$($site):SMS_Collection").CreateInstance()
								$CMCollection.Name=$collectionNameOSDeployed
								$CMCollection.Comment=$collectionCommentOSDeployed
								$CMCollection.OwnedByThisSite=$true
								$CMCollection.LimitToCollectionID=$parentColl
								$CMCollection.Put()
								$CMCollection.Get() 
								
								$validateQuery="Select * from SMS_R_SYSTEM Inner join SMS_R_iDRAC ON  (SMS_R_SYSTEM.SMBIOSGUID=SMS_R_iDRAC.SMBIOSGUID OR SMS_R_SYSTEM.NETBIOSNAME=SMS_R_iDRAC.NETBIOSNAME) WHERE SMS_R_SYSTEM.Client=1"
								$ruleName="11G_OS_Rule"
								
								$ValidatingQuery = Invoke-WmiMethod -Namespace $ns -Class SMS_CollectionRuleQuery -Name ValidateQuery -ArgumentList $validateQuery
								if($ValidatingQuery -eq $null){
									return "Status:$response_FAIL,Message:Validation of query failed"
								}
								
								Write-Log -Message "Create new Query Rule" 
								$NewRule = ([WMIClass]"\\.\Root\SMS\Site_$($site):SMS_CollectionRuleQuery").CreateInstance()
								$NewRule.QueryExpression=$validateQuery
								$NewRule.RuleName=$ruleName
								
			
								$CMCollection.CollectionRules    += $NewRule.psobject.baseobject
								$put                             = $CMCollection.Put()
								$refresh                         = $CMCollection.RequestRefresh()
								$retCode=$true
														
								}
						}
					}
				}
			}
		}
        Write-Log -Message "--------------------------------------------------------------------------------------"
        Write-Log -Message "--------------------------------------------------------------------------------------"
		Write-Log -Message "AuotDiscovery of Server in SCCM Finished"
        Write-Log -Message "--------------------------------------------------------------------------------------"
        Write-Log -Message "--------------------------------------------------------------------------------------"
	}-Args $DomainUsername,$ComputerName,$SccmSmBiosGuid,$siteCode -ErrorVariable errmsg  2>$null
	
	if($emsg -match "FAIL"){
		$returnval=$returnval+"FAIL"
		$returnval=$returnval+$emsg
		return $returnval
	}else{
	
		$returnval=$returnval+"SUCCESS"
		$returnval=$returnval+"DDR created successfully"
		return $returnval
	}
}catch{
	$returnval=$returnval+"FAIL"
	$returnval=$returnval+$_.Exception.Message
	return $returnval
}