param($ComputerName,$DomainUsername,$DelPwd,$tejasFQDN,$info)

#$DomainUsername="MYDOMAIN\Administrator"
#$DelPwd="Dell_123$"

############### VARIABLES ###########################

set-variable -name Response_Success -value "SUCCESS" 
set-variable -name Response_FAIL -value "FAIL"

############### VARIABLES ###########################

<############### INFORMATION ###########################

Last Run Codes
0 - The operation completed successfully.
1 - Incorrect function called or unknown function called. 
2 - File not found.
10 - The environment is incorrect. 
267008 - Task is ready to run at its next scheduled time. 
267009 - Task is currently running. 
267010 - The task will not run at the scheduled times because it has been disabled. 
267011 - Task has not yet run. 
267012 - There are no more runs scheduled for this task. 
267013 - One or more of the properties that are needed to run this task on a schedule have not been set. 
267014 - The last run of the task was terminated by the user. 
267015 - Either the task has no triggers or the existing triggers are disabled or not set. 
2147750671 - Credentials became corrupted. 
2147750687 - An instance of this task is already running. 
2147943645 - The service is not available (is "Run only when an user is logged on" checked?). 
3221225786 - The application terminated as a result of a CTRL+C. 
3228369022 - Unknown software exception.
############### INFORMATION ###########################>

# Create Credential obj
Function Createcredobj($username, $passwd)
{
    try
    {
             $secpasswd = ConvertTo-SecureString  $passwd -AsPlainText -Force
        $mycredsobj = New-Object System.Management.Automation.PSCredential ($username, $secpasswd)
        #$Error
    }
    catch
    {
        $mycredsobj = $null
    }

    return $mycredsobj
}

$returnval=@()

try{
    
    $cred= Createcredobj $DomainUsername $DelPwd
	$clusterFqdnName=$info.split(",")[0]
	$hotFixConfigFile=$info.split(",")[1]
	$hotfixRootPath=$info.split(",")[2]
	
	
    #time added to the current time to execute the task one min
    $ts = New-TimeSpan -Days 0 -Hours 0 -Minutes 2 -Seconds 0
    $timeToTrigger=(Get-Date)+$ts

    #Write-Output $timeToTrigger
	[System.Guid] $guidObject = [System.Guid]::NewGuid()
	$jobName="dell_"+$guidObject.Guid
	
    #$jobname = "Cluster Aware Task"
    $script =  "-ExecutionPolicy Bypass -file $hotfixRootPath\invokecau.ps1 -DomainUsername $DomainUsername -DelPwd $DelPwd -clusterFqdnName $clusterFqdnName -hotFixConfigFile $hotFixConfigFile -hotfixRootPath $hotfixRootPath"
	write-output $script
    ipmo ScheduledTasks

    #remove an existing CAU task
    Unregister-ScheduledTask -TaskName $jobname 

    #Create a Win Task ACtion
    $action = New-ScheduledTaskAction "powershell.exe" -Argument $script
    #Write-Output "Action : "$action

    #Set the trigger for the task
    $trigger = New-ScheduledTaskTrigger -Once -At $timeToTrigger
    #Write-Output "Trigger: "$trigger

    #set the Principal for the Task
    $principal=New-ScheduledTaskPrincipal $DomainUsername
    #Write-Output "Principal: "$principal

    #configure the task settings
    $settings = New-ScheduledTaskSettingsSet 
    #-AllowStartIfOnBatteries -DontStopIfGoingOnBatteries -StartWhenAvailable -DontStopOnIdleEnd -AsJob
    #Write-Output "Settings: "$settings

    #create the task
    $task = New-ScheduledTask -Action $action -Principal $principal -Trigger $trigger -Settings $settings
    #Write-Output "Task: "$task

    #Register the  scheduled task definition on local computer
    $res=Register-ScheduledTask -TaskName $jobname  -RunLevel Highest -User $DomainUsername -Password $DelPwd -Action $action -Trigger $trigger -Settings $settings 
    #Write-Output "Reg" $res
	
	$isTask=Get-ScheduledTask -TaskName $jobname
	if($isTask -ne $null){
	if($isTask.State -eq "Ready"){
		
		$returnval = $returnval + $Response_Success
		$result=Get-ScheduledTaskInfo -TaskName $jobname
		
		#Get the Last Run Status of the task 
		$lastRunStatus=$result.LastTaskResult
		
		if($lastRunStatus -eq 267011){
			
			#Task has not yet run 
			$state="Pending"
			
		}if($lastRunStatus -eq 267009 -or $lastRunStatus -eq 2147750687){
			
			#task is currently runing
			$state="Running"
			
		}if($lastRunStatus -eq 0){
			$state="Completed Successfully"
		}
		$returnval = $returnval + "Status:Scheduled Task Created Successfully,ID:$jobname,State:$state"
		
	}else{
		$returnJson="Creation of Scheduled task was unsuccessfull "+$isTask.State
		$returnval = $returnval + $Response_FAIL
		$returnval = $returnval + $returnJson
	}
	}else{
		$returnval = $returnval + $Response_FAIL
		$returnval = $returnval + "Task was not created"
	}
   

}catch{
    $returnval = $returnval + $Response_FAIL
    $returnval = $returnval + $_Error.Message
}
return $returnval

