param($ComputerName,$DelUserName,$DomainUsername,$DelPwd,$tejasFQDN,$uuid)
<#
$ComputerName = "sksccm.mydomain.com"
$DomainUsername = "mydomain\administrator"
$DelPwd = "Dell_123$"
$tejasFQDN = "tejas1137.mydomain.com"
$uuid ="44454c4c-5300-1058-8044-b5c04f573232"
#>

# Create obj
Function Createcredobj($username, $passwd)
{

    try
    {
		$secpasswd = ConvertTo-SecureString  $passwd -AsPlainText -Force
        $mycredsobj = New-Object System.Management.Automation.PSCredential ($username, $secpasswd)
        #$Error
    }
    catch
    {
        $mycredsobj = $null
    }

    return $mycredsobj

}



$uuid = $uuid -replace "\\n\\r", " "

$returnval = @()

$sccmCred= Createcredobj $DomainUsername $DelPwd
$emsg=@()

try{
       #step 0. Create connection with SCCM machine and get the site code
        $siteCode=Invoke-Command -ComputerName $ComputerName -Credential $sccmCred -ConfigurationName Microsoft.PowerShell32 -ScriptBlock{
                Import-Module -Name "$(split-path $Env:SMS_ADMIN_UI_PATH)\ConfigurationManager.psd1"
	   	        $PSD = Get-PSDrive -PSProvider CMSite
	            if($PSD -eq $null){
			        New-PSDrive -Name "LOCAL" -PSProvider CMSite -Root $args[0]
			        $PSDN = Get-PSDrive -PSProvider CMSite -Name "LOCAL"
			        $SiteCode= CD "$($PSDN):"
		        }else{
	                $SiteCode= CD "$($PSD):"	
		        }
	            $VMMobj= Get-CMSite
                if ( $VMMobj -ne $null ){
			
			        return $VMMobj.SiteCode
	            }else{
			        return "Site Code of the SC was not identified"
		        }
        }-Args $ComputerName -ErrorVariable errmsg  2>$null

	$emsg=Invoke-Command -ComputerName $ComputerName -Credential $sccmCred -ConfigurationName Microsoft.PowerShell32 -ScriptBlock{
    
   	
		############### CONSTANTS ###########################
	
		
		############### CONSTANTS ###########################
		
		#Step 1. Get the Site Code
        function Write-Log
        {
            param (
                [Parameter(Mandatory)]
                [string]$Message,
        
                [Parameter()]
                [ValidateSet('1','2','3')]
                [int]$Severity = 1 ## Default to a low severity. Otherwise, override
            )
    
            $line = [pscustomobject]@{
                'DateTime' = (Get-Date -Format "yyyy-MM-dd HH:mm:ss:ffff")
                'Message' = $Message
            }
    
            ## Ensure that $LogFilePath is set to a global variable at the top of script
            $line | Export-Csv -Path $LogFilePath -Append -NoTypeInformation
        }

        $logBasePath="$(split-path $Env:SMS_ADMIN_UI_PATH)";
        $logFilePath="OMIMSSC_Discovery.log"

        $global:LogFilePath = Join-Path $logBasePath $logFilePath

       try{

        if (!(Test-Path $LogFilePath)) {
            
            $NewLogFile = New-Item $LogFilePath -Force -ItemType File
          }

        else {
            # Nothing to see here yet.
            }
         }catch{
            $tempPath =[System.IO.Path]::GetTempPath()
            $basePath = [io.path]::combine($tempPath + "Log")
            $logFile=  Join-Path $basePath  $logFilePath 
            [system.io.directory]::CreateDirectory($logFile)
            $LogFilePath=$logFile
         }
        Write-Log -Message "--------------------------------------------------------------------------------------"
        Write-Log -Message "--------------------------------------------------------------------------------------"
		Write-Log -Message "Deletion of Server in SCCM Started"
        Write-Log -Message "--------------------------------------------------------------------------------------"
        Write-Log -Message "--------------------------------------------------------------------------------------"
		$site=$args[3]
		$ns="root\sms\site_$site"
		#Step 2. Convert UUID to SMBIOS Guid
		$formattedguid=$null
		$uuid=$args[2]
		Write-Log -Message "UUID of server is ='$uuid'"
		$token=$args[2].split('-')
		$formattedguid=$formattedguid+$token[0].SubString(6,2)+$token[0].SubString(4,2)+$token[0].SubString(2,2)+$token[0].SubString(0,2)
        $formattedguid=$formattedguid+"-"+$token[1].SubString(2,2)+$token[1].SubString(0,2)
		$formattedguid=$formattedguid+"-"+$token[2].SubString(2,2)+$token[2].SubString(0,2)
		$formattedguid=$formattedguid+"-"+$token[3].SubString(0,4)
		$formattedguid=$formattedguid+"-"+$token[4].SubString(0,12)
		$smbios=$formattedguid
        #$smbios=$uuid
         Write-Log -Message "smbios of server is ='$smbios'"
        #Step 7. Delete the old DDR
		#Start deleting the old DDR
		$queryDelIdrac="Select resourceID from SMS_R_iDRAC where SMBIOSGUID = '$smbios'"
		$queryResultsforIdracs=Get-WMIObject -Query $queryDelIdrac -Namespace $ns
           
		if($queryResultsforIdracs -ne $null){
			foreach($queryResultforIdrac in $queryResultsforIdracs){
			
				$resourceID=$queryResultforIdrac.resourceID
			    $comp=$queryResultforIdrac
				$comp.psbase.delete()
			}
		}
		Write-Log -Message "Deleted the system from SMS_R_IDRAC"
		$queryDelSystem="Select resourceID from SMS_R_System WHERE SMBIOSGUID = '$smbios'"
		$queryResultsforSystems=Get-WMIObject -Query $queryDelSystem -Namespace $ns
				
		if($queryResultsforSystems -ne $null){
			foreach($queryResultforSystem in $queryResultsforSystems){
				$comp=$queryResultforSystem
				$comp.psbase.delete()
			}
		}
        Write-Log -Message "Message:Deleted SmbiosGUID from SMS_R_System and iDRAC"

        Write-Log -Message "--------------------------------------------------------------------------------------"
        Write-Log -Message "--------------------------------------------------------------------------------------"
		Write-Log -Message "Deletion of Server in SCCM Finished"
        Write-Log -Message "--------------------------------------------------------------------------------------"
        Write-Log -Message "--------------------------------------------------------------------------------------"
        return "Status:SUCCESS,Message:Deleted SmbiosGUID from SMS_R_System and iDRAC"
		#Finished deleting the old DDR

		
	}-Args $DomainUsername,$ComputerName,$uuid,$siteCode -ErrorVariable errmsg  2>$null
	if($emsg -match "FAIL"){
		$returnval=$returnval+"FAIL"
		$returnval=$returnval+$emsg
		return $returnval
	}else{
	
		$returnval=$returnval+"SUCCESS"
		$returnval=$returnval+"DDR deleted successfully"
		return $returnval
	}
}catch{
	$returnval=$returnval+"FAIL"
	$returnval=$returnval+$_.Exception.Message
	return $returnval
}