﻿param($ParamDenroll,$ParamServiceTagList)
$ErrorActionPreference = "SilentlyContinue"
$OMPSInstallKey = "HKLM:\Software\Microsoft\System Center Operations Manager\12\Setup\Powershell\V2"
$regKey = get-item $OMPSInstallKey
$OMPSInstallPath = $regKey.GetValue("InstallDirectory")
$omModule = $OMPSInstallPath + "OperationsManager"
Import-Module -Name $omModule
$fqdn = [System.Net.Dns]::GetHostByName(($env:computerName))
$computerName = $fqdn.HostName
$mg = New-Object -TypeName "Microsoft.EnterpriseManagement.ManagementGroup" -ArgumentList @($computerName)
$discoveryData = new-Object -TypeName "Microsoft.EnterpriseManagement.ConnectorFramework.IncrementalDiscoveryData"
$ServiceTagList = $ParamServiceTagList.Split(',')
$scomobjects =  Get-SCOMClass -DisplayName "Dell*" | Get-SCOMClassInstance

if($ParamDenroll -eq $true)
{
    foreach($scomobject in $scomobjects)
    {
        $DiscoveryData.Remove($scomobject)
	    $DiscoveryData.commit($scomobject.ManagementGroup)
    }
}
elseif($ParamDenroll -eq $false)
{
    foreach($scomobject in $scomobjects)
    {
        foreach($serviceTag in $ServiceTagList)
        {
            if($scomobject.FullName -match $serviceTag)
            {
                $scomobject.FullName
                $DiscoveryData.Remove($scomobject)
	            $DiscoveryData.commit($scomobject.ManagementGroup)
                continue;
            }
        }
    }
}

