param($ComputerName,$DomainUsername,$DelPwd,$tejasFQDN,$info)

############### CONSTANTS ###########################

set-variable -name Response_Success -value "SUCCESS" -option constant
set-variable -name Response_FAIL -value "FAIL" -option constant
#set-variable -name REPORT_TARGET_FILE_LOCATION -value "\UPDATE\reports\" -option constant
set-variable -name UPDATE_SHARE -value "\\\\localhost\\UPDATE\\" -option constant

############### CONSTANTS ###########################
# Create Credential obj
Function Createcredobj($username, $passwd)
{

    try
    {
		$secpasswd = ConvertTo-SecureString  $passwd -AsPlainText -Force
        $mycredsobj = New-Object System.Management.Automation.PSCredential ($username, $secpasswd)
        #$Error
    }
    catch
    {
        $mycredsobj = $null
    }

    return $mycredsobj

}
$info = $info -replace "\\n\\r", " "
$clusterFQDN=$info.split(",")[0]
$reportFormat=$info.split(",")[1] #it will be HTML all the time
$REPORT_TARGET_FILE_LOCATION=$info.split(",")[2]+"\reports\"
$reportTargetFileWithLocation=""
$returnval= @()
$cred =Createcredobj $DomainUsername $DelPwd

try{

	#import SCVMM related cmdlets
	import-module virtualmachinemanager
	
	if([string]::IsNullorEmpty($clusterFQDN)){
		#throw error if the clusterFQDN is not present
		$returnval = $returnval + $Response_FAIL
		$returnval = $returnval + "Message:Arg clusterFqdNName is null. Get-CauReport Operation Completed Unsuccessfully"
		return $returnval
	}
	
	$reportTargetFileWithLocation=$REPORT_TARGET_FILE_LOCATION + $clusterFQDN
	$reportTargetFileWithLocation = $reportTargetFileWithLocation + "." + $reportFormat.ToLower()
	
	$isExists=Test-Path $reportTargetFileWithLocation
	if($isExists -eq $true){
		#delete the path
		Remove-Item $reportTargetFileWithLocation -recurse -force
	}
	
	#powershell command to get the Cau report
	$report=Get-CauReport -Last -Detailed -credential $cred -ClusterName $clusterFQDN | Export-CauReport -Format $reportFormat -Path $reportTargetFileWithLocation -Force
	
	if($?){
		#the generate report is sucess
		$nowExists=Test-Path $reportTargetFileWithLocation
		if($nowExists -eq $true){
		
			$returnval = $returnval + $Response_Success
			$returnval = $returnval + "Get-CauReport Operation Completed Successfully"
		}else{
			
			$returnval = $returnval + $Response_FAIL
			$returnval = $returnval + "Export-CauReport Operation Completed Unsccessfully"
			
		}
	}else{
		#the report couldnt get generated
		$returnval = $returnval + $Response_FAIL
		$returnval = $returnval + "get-CauReport and Export-CauReport Operation Completed Unsuccessfully"
	}
	
}catch{
	$returnval = $returnval + $Response_FAIL
	$returnval = $returnval + $_.Exception.Message
}

return $returnval
