param($ComputerName,$DomainUsername,$DelPwd,$tejasFQDN,$info)

############### CONSTANTS ###########################

set-variable -name Response_Success -value "SUCCESS" -option constant
set-variable -name Response_FAIL -value "FAIL" -option constant

############### CONSTANTS ###########################

## This script get the CAU update report  
#$clusterFqdnName='NODECLUSTER'

# Create Credential obj
Function Createcredobj($username, $passwd)
{

    try
    {
		$secpasswd = ConvertTo-SecureString  $passwd -AsPlainText -Force
        $mycredsobj = New-Object System.Management.Automation.PSCredential ($username, $secpasswd)
        #$Error
    }
    catch
    {
        $mycredsobj = $null
    }

    return $mycredsobj

}


$debug1 = 1
# Return Value
$returnval = @()
$clusterFqdnName=$info
$cred =Createcredobj $DomainUsername $DelPwd

try
{
	
	#$cauReport=(Get-CauReport -ClusterName $clusterFqdnName -Last -Detailed)	
	$cauReport=Get-CauReport -ClusterName $clusterFqdnName -credential $cred -Last
	if ($?)
	{
		$returnJson="Report:"+$cauReport.Status
		$returnval = $returnval + $Response_Success
		$returnval = $returnval + $returnJson
		#$returnval = $returnval + $cauReport
	}else
	{	
		$returnval = $returnval + $Response_FAIL
		$returnval = $returnval + "Get-CauUpdateReport Operation Completed Unsuccessfully"
		#$returnval = $returnval + $cauReport
	}	
	if ($debug1 -eq 0)
	{
		#write-host $cauReport
		write-host $returnval
	}
	
	return $returnval
}catch [exception]
{
		$returnval = $returnval + $Response_FAIL
		$returnval = $returnval + $Error[0].Exception
}


return $returnval

