param($ComputerName,$DomainUsername,$DelPwd,$tejasFQDN,$uuid)
<#
$ComputerName = "sksccm.mydomain.com"
$DomainUsername = "mydomain\administrator"
$DelPwd = "Dell_123$"
$tejasFQDN = "tejas1137.mydomain.com"
$uuid ="4c4c4544-0053-5810-8044-b5c04f573232"
#$uuid ="44454c4c-5300-1058-8044-b5c04f573232"
#>

Function Createcredobj($username, $passwd){
    try{
		$secpasswd = ConvertTo-SecureString  $passwd -AsPlainText -Force
        $mycredsobj = New-Object System.Management.Automation.PSCredential ($username, $secpasswd)
        #$Error
    }
    catch{
        $mycredsobj = $null
    }

    return $mycredsobj
}



$uuid = $uuid -replace "\\n\\r", " "


$returnval = @()


$sccmCred= Createcredobj $DomainUsername $DelPwd
$emsg=@()

try{

    #step 0. Create connection with SCCM machine and get the site code
        $siteCode=Invoke-Command -ComputerName $ComputerName -Credential $sccmCred -ConfigurationName Microsoft.PowerShell32 -ScriptBlock{
                Import-Module -Name "$(split-path $Env:SMS_ADMIN_UI_PATH)\ConfigurationManager.psd1"
	   	        $PSD = Get-PSDrive -PSProvider CMSite
	            if($PSD -eq $null){
			        New-PSDrive -Name "LOCAL" -PSProvider CMSite -Root $args[0]
			        $PSDN = Get-PSDrive -PSProvider CMSite -Name "LOCAL"
			        $SiteCode= CD "$($PSDN):"
		        }else{
	                $SiteCode= CD "$($PSD):"	
		        }
	            $VMMobj= Get-CMSite
                if ( $VMMobj -ne $null ){
			
			        return $VMMobj.SiteCode
	            }else{
			        return "Site Code of the SC was not identified"
		        }
        }-Args $ComputerName -ErrorVariable errmsg  2>$null
	$emsg=Invoke-Command -ComputerName $ComputerName -Credential $sccmCred -ConfigurationName Microsoft.PowerShell32 -ScriptBlock{
    
   	
		############### CONSTANTS ###########################
		
		set-variable -name Response_Success -value "SUCCESS" -option constant
		set-variable -name Response_FAIL -value "FAIL" -option constant
		set-variable -name Exception_Code -value 101 -option constant
		set-variable -name zeroguid -value "00000004-0000-0000-0000-000000000000" -option constant
		set-variable -name collectionNameAllSystems -value "All Systems" -option constant
		set-variable -name osNameVersionIndex -value "0,1,2,3,4,5,6,7,8,9" -option constant
		set-variable -name collectionNameImportDellServers -value "Dell Imported Servers" -option constant
		set-variable -name collectionNameAllDellLCControllers -value "All Dell Lifecycle Controller Servers" -option constant
		set-variable -name collectionCommentImportDellServers -value "All Dell PowerEdge servers discovered using Import Dell PowerEdge servers wizard" -option constant
		set-variable -name collectionCommentAllDellLCControllers -value "All Dell PowerEdge servers" -option constant
		set-variable -name collectionNameRhel -value "managed dell lifecycle controller(rhel)" -option constant
		set-variable -name collectionNameEsxi -value "managed dell lifecycle controller(esxi)" -option constant
		set-variable -name osRhel -value "rhel" -option constant
		set-variable -name osEsxi -value "esxi" -option constant
		set-variable -name collectionCommentAllDellLCControllers -value "All Dell PowerEdge servers" -option constant
		
		############### CONSTANTS ###########################
		function Write-Log
        {
            param (
                [Parameter(Mandatory)]
                [string]$Message,
        
                [Parameter()]
                [ValidateSet('1','2','3')]
                [int]$Severity = 1 ## Default to a low severity. Otherwise, override
            )
    
            $line = [pscustomobject]@{
                'DateTime' = (Get-Date -Format "yyyy-MM-dd HH:mm:ss:ffff")
                'Message' = $Message
            }
    
            ## Ensure that $LogFilePath is set to a global variable at the top of script
            $line | Export-Csv -Path $LogFilePath -Append -NoTypeInformation
        }

        $logBasePath="$(split-path $Env:SMS_ADMIN_UI_PATH)";
        $logFilePath="OMIMSSC_Discovery.log"

        $global:LogFilePath = Join-Path $logBasePath $logFilePath

       try{

        if (!(Test-Path $LogFilePath)) {
            
            $NewLogFile = New-Item $LogFilePath -Force -ItemType File
          }

        else {
            # Nothing to see here yet.
            }
         }catch{
            $tempPath =[System.IO.Path]::GetTempPath()
            $basePath = [io.path]::combine($tempPath + "Log")
            $logFile=  Join-Path $basePath  $logFilePath 
            [system.io.directory]::CreateDirectory($logFile)
            $LogFilePath=$logFile
         }

        Write-Log -Message "--------------------------------------------------------------------------------------"
        Write-Log -Message "--------------------------------------------------------------------------------------"
		Write-Log -Message "Deletion of host Server in SCCM Started"
        Write-Log -Message "--------------------------------------------------------------------------------------"
        Write-Log -Message "--------------------------------------------------------------------------------------"
		$site=$args[3]
		$ns="root\sms\site_$site"
		
		#Step 2. Convert UUID to SMBIOS Guid
        
		$formattedguid=$null
		$uuid=$args[2]
		$token=$args[2].split('-')
		Write-Log -Message "UUID of server= '$uuid'"
		$formattedguid=$formattedguid+$token[0].SubString(6,2)+$token[0].SubString(4,2)+$token[0].SubString(2,2)+$token[0].SubString(0,2)
		$formattedguid=$formattedguid+"-"+$token[1].SubString(2,2)+$token[1].SubString(0,2)
		$formattedguid=$formattedguid+"-"+$token[2].SubString(2,2)+$token[2].SubString(0,2)
		$formattedguid=$formattedguid+"-"+$token[3].SubString(0,4)
		$formattedguid=$formattedguid+"-"+$token[4].SubString(0,12)
		
		$smbios=$formattedguid
		Write-Log -Message "SMBIOS GUID='$smbios'"
		#Step 3. Get the hostname from the UUID or the SMbios
        Write-Log -Message "Get the host name from the UUID or the SMbios"
		$deployedOSList=@()
		$hostname=$null
		
		if($smbios -ne $null -or $smbios -ne $zeroguid){
			$query="Select * from SMS_R_SYSTEM where SMBIOSGUID='$smbios'"
			$response=Get-WMIObject -query $query -namespace $ns
			
			if($response -ne $null){
				foreach($row in $response){
					$hostNameFromSmbios=$row.NetbiosName
				}
			}
			
			$query="Select * from SMS_R_SYSTEM where SMBIOSGUID='$uuid'"
			$response=Get-WMIObject -query $query -namespace $ns
			
			if($response -ne $null){
				foreach($row in $response){
					$hostNameFromUuid=$row.NetbiosName
				}
			}
			
			if([string]::IsNullorEmpty($hostNameFromUuid)){
				if(![string]::IsNullorEmpty($hostNameFromSmbios)){
					$hostname=$hostNameFromSmbios
				}
				
			}else{
				$hostname=$hostNameFromUuid
			}
			Write-Log -Message "Host Name: $hostname"
			#Step 4. Get the detailed list of Deployed OS/ Hosts
            Write-Log -Message "Get the detailed list of Deployed OS/ Hosts"
			if(![string]::IsNullorEmpty($hostname)){
			
				#Step 5. Get the collection Name list for the the hostname
                Write-Log -Message "Get the collection Name list for the the hostname"
				$collList=@()
				$collectionList=""
				$queryColl="select SC.Name from SMS_Collection SC join SMS_FullCollectionMembership SFCM on SC.CollectionID = SFCM.CollectionID Where SFCM.Name = '$hostname'"
				$resultColl=Get-WMIObject -Query $queryColl -Namespace $ns
	            Write-Log -Message "$queryColl"
				foreach($coll in $resultColl){
					$collList=$collList+$coll.Name
				}
				Write-Log -Message "Collection List: $collList"
				foreach($col in $collList){
					if($col -eq $collectionNameImportDellServers){
						$isImpoterdDellColExist=$true
					}
				
					if($col -eq $collectionNameAllDellLCControllers){
						$isAllDellColExist=$true
					}
					if($col -eq "All Desktop and Server Clients" -or $col -eq "All Systems")
					{
						continue
					}
					else{
						$collectionList=$collectionList+$col+"&"
					}
				}
			
				if(!$isImpoterdDellColExist){
					$collectionList=$collectionList+$collectionNameImportDellServers+"&"
				}
				if(!$isAllDellColExist){
					$collectionList=$collectionList+$collectionNameAllDellLCControllers+"&"
				}
			
				$list=$collectionList.SubString(0,$collectionList.Length-1)
				
				$collectionName=$list
				Write-Log -Message "List: '$list'"
				
				#Step 6. Get other details from sms_r_system 
                Write-Log -Message "Get other details from sms_r_system "
				$query="Select * from SMS_R_SYSTEM WHERE NETBIOSNAME='$hostname'"
				$response=Get-WMIObject -Query $query -Namespace $ns
				Write-Log -Message "$query"
				if($response -ne $null){
					foreach($row in $response){
					     Write-Log -Message "Client value:  $row.Client"
						if($row.Client -eq "1"){
							Write-Log -Message "if the client is installed"
							if(![string]::IsNullOrEmpty($row.OperatingSystemNameandVersion)){
								$index=0
								Write-Log -Message "get the index from which the version starts in OperatingSystemNameandVersion from WMI"
								foreach($versionIndex in $osNameVersionIndex){
									if($row.OperatingSystemNameandVersion -match $versionIndex){
										$index=$row.OperatingSystemNameandVersion.IndexOf($versionIndex)
									}
								}
					
								$oname=$row.OperatingSystemNameandVersion.SubString(0,$index)
								$oversion=$row.OperatingSystemNameandVersion.SubString($index)
								#$collectionName=(getAllCollection $hostnameparam $nsparam)
								Write-Log -Message "IP: $row.IPAddresses"
								$deployedOSList=$deployedOSList+@($row.SMBIOSGUID,$row.IPAddresses,$row.Name,"",$oname,$oversion,$collectionName)
							}
						}else{
							Write-Log -Message "For Non OS host, get the OS Name from iDrac"
							$queryIdrac="Select * from SMS_R_iDRAC where NetbiosName = '$hostname'"
							$resultIdrac=Get-WMIObject -Query $queryIdrac -Namespace $nsparam
				
	
							foreach($singleResult in $resultIdrac){
								if(![string]::IsNullOrEmpty($singleResult.OSName)){
									#$collectionName=(getAllCollection $hostnameparam $nsparam)
									
									if(($collectionName.ToLower() -match "managed dell lifecycle controller(rhel)") -or ($collectionName.ToLower() -match "managed dell lifecycle controller(esxi)") -or ($singleResult.OSName.ToLower() -match $osRhel) -or ($singleResult.OSName.ToLower() -match $osEsxi)){
						
										$deployedOSList=$deployedOSList+@($row.SMBIOSGUID,$row.IPAddresses,$row.Name,"",$singleResult.OSName,"",$collectionName)
									}
								}
							}
						}
					}
					Write-Log -Message "deployedOSList: $deployedOSList"
				}
				
				#Step 7. Delete the server if the list is null
                Write-Log -Message "Delete the server if the list is null"
				if($deployedOSList -eq $null -or $deployedOSList.Count -eq 0 -or [string]::IsNullOrEmpty($deployedOSList)){
					#Start deleting the old DDR
					$queryDelIdrac="Select resourceID from SMS_R_iDRAC where SMBIOSGUID = '$smbios'"
					$queryResultsforIdracs=Get-WMIObject -Query $queryDelIdrac -Namespace $ns
					   
					if($queryResultsforIdracs -ne $null){
						foreach($queryResultforIdrac in $queryResultsforIdracs){
						
							$resourceID=$queryResultforIdrac.resourceID
							$comp=$queryResultforIdrac
							$comp.psbase.delete()
						}
					}
					
					$queryDelSystem="Select resourceID from SMS_R_System WHERE SMBIOSGUID = '$smbios'"
					$queryResultsforSystems=Get-WMIObject -Query $queryDelSystem -Namespace $ns
							
					if($queryResultsforSystems -ne $null){
						foreach($queryResultforSystem in $queryResultsforSystems){
							$comp=$queryResultforSystem
							$comp.psbase.delete()
						}
					}
                     Write-Log -Message "Finished deleting the old DDR"
					#Finished deleting the old DDR
				}
				
				#Step 8. Send the response
				$isHostPresent=$deployedOSList
				if([string]::IsNullOrEmpty($deployedOSList)){
                    Write-Log -Message "Message:Host DOES not EXISt"
                    Write-Log -Message "--------------------------------------------------------------------------------------"
                    Write-Log -Message "--------------------------------------------------------------------------------------"
		            Write-Log -Message "Deletion of host in SCCM Finished"
                    Write-Log -Message "--------------------------------------------------------------------------------------"
                    Write-Log -Message "--------------------------------------------------------------------------------------"
					return "Status:SUCCESS,Message:Host DOES not EXISt"
				}else{
					$returnJson="Status:SUCCESS,"
					$returnJson=$returnJson+"SMBIOS:$uuid,"
					if([string]::IsNullOrEmpty($isHostPresent[0])){
						$returnJson=$returnJson+"IdracIp:$null,"
					}else{
						$returnJson=$returnJson+"IdracIp:"+$isHostPresent[1]+","
					}
					
					$returnJson=$returnJson+"Protocol:$null,MarkedForDeletion:NA,"
					
					if([string]::IsNullOrEmpty($isHostPresent[2])){
						$returnJson=$returnJson+"HostName:$null,"
					}else{
						$returnJson=$returnJson+"HostName:"+$isHostPresent[2]+","
					}
					
					
					if([string]::IsNullOrEmpty($isHostPresent[3])){
						$returnJson=$returnJson+"FQDN:$null,"
					}else{
						$returnJson=$returnJson+"FQDN:"+$isHostPresent[3]+","
					}
					if([string]::IsNullOrEmpty($isHostPresent[4])){
						$returnJson=$returnJson+"OSName:$null,"
					}else{
						$returnJson=$returnJson+"OSName:"+$isHostPresent[4]+","
					}
					if([string]::IsNullOrEmpty($isHostPresent[5])){
						$returnJson=$returnJson+"OSVersion:$null,"
					}else{
						$returnJson=$returnJson+"OSVersion:"+$isHostPresent[5]+","
					}
					$returnJson=$returnJson+"ClusterFQDN:$null,"
					
					if([string]::IsNullorEmpty($isHostPresent[6])){
						$returnJson=$returnJson+"GroupName:$null"
					}else{
						$returnJson=$returnJson+"GroupName:"+$isHostPresent[6]
					}
					Write-Log -Message " $returnJson"
					Write-Log -Message "Message:Host DOES EXISt $returnJson"
                    Write-Log -Message "--------------------------------------------------------------------------------------"
                    Write-Log -Message "--------------------------------------------------------------------------------------"
		            Write-Log -Message "Deletion of host in SCCM Finished"
                    Write-Log -Message "--------------------------------------------------------------------------------------"
                    Write-Log -Message "--------------------------------------------------------------------------------------"
					return $returnJson
				}
				
				
			}else{
                Write-Log -Message "Message:Host DOES not EXISt"
                Write-Log -Message "--------------------------------------------------------------------------------------"
                Write-Log -Message "--------------------------------------------------------------------------------------"
		        Write-Log -Message "Deletion of host in SCCM Finished"
                Write-Log -Message "--------------------------------------------------------------------------------------"
                Write-Log -Message "--------------------------------------------------------------------------------------"
				return "Status:SUCCESS,Message:Host DOES not EXISt"
			}
			
		}else{
            Write-Log -Message "Message:Host DOES not EXISt"
            Write-Log -Message "--------------------------------------------------------------------------------------"
            Write-Log -Message "--------------------------------------------------------------------------------------"
		    Write-Log -Message "Deletion of host in SCCM Finished"
            Write-Log -Message "--------------------------------------------------------------------------------------"
            Write-Log -Message "--------------------------------------------------------------------------------------"
			return "Status:SUCCESS,Message:Host DOES not EXISt"
		}
		
		
	}-Args $DomainUsername,$ComputerName,$uuid,$siteCode -ErrorVariable errmsg  2>$null
	if($emsg -match "SUCCESS"){
		$returnval=$returnval+"SUCCESS"
		$returnval=$returnval+$emsg
		return $returnval
	}else{
		$returnval=$returnval+"FAIL"
		$returnval=$returnval+$emsg
		return $returnval
	}
}catch{
	$returnval=$returnval+"FAIL"
	$returnval=$returnval+$_.Exception.Message
	return $returnval	
}