param($ComputerName,$DomainUsername,$DelPwd,$tejasFQDN,$SmBiosGuid)
## This script gets the SCVMM Host object by using the SMBios GUID
$debug1 = 1

# Return Value
$returnval = @()
$temp = @("null") 
  
#$smbios_guid = "4c4c4544-0039-4810-8051-b4c04f383253"
#$DelUserName='tejas\administrator'
#$DelPwd='Dell_123$'
#$VMMServer='scvmm'

# Create obj
Function Createcredobj($username, $passwd)
{

    try
    {
		$secpasswd = ConvertTo-SecureString  $passwd -AsPlainText -Force
        $mycredsobj = New-Object System.Management.Automation.PSCredential ($username, $secpasswd)
        #$Error
    }
    catch
    {
        $mycredsobj = $null
    }

    return $mycredsobj

}

# Create SCVMM Cred obj    
    $scvmmcreds = Createcredobj $DomainUsername $DelPwd
    if ( $scvmmcreds -eq $null)
    {
        $returnval = $returnval + "FAIL"
		$returnval = $returnval + "Could not create credentail object for the given SCVMM user"
		return $returnval
    }

# A user can have mutiple role, in Tejasconext we are connecting always as DelegatedAdmin Role.

    try 
    {
    	#import SCVMM related cmdlets
		import-module virtualmachinemanager
        $VMMobj = Get-SCVMMServer -ComputerName $ComputerName -Credential $scvmmcreds 
    }
    catch [exception]
    {
        $returnval = $returnval + "FAIL"
		$returnval = $returnval + $Error[0].Exception
        if ($debug1 -eq 0)
		{
			write-host $returnval
		}
		return $returnval
    }

    if ( $VMMobj -eq $null)
    {
        $returnval = $returnval + "FAIL"
        $returnval = $returnval + "SCVMM host not reachable"
        if ($debug1 -eq 0)
		{
			write-host $returnval
		}
		return $returnval
       
    }
	else
    {

		try
		{
			# Search for the Host object
			$myhost = (Get-scvmhost -VMMServer $VMMobj | where {$_.PhysicalMachine.SMBiosGUID -eq $SmBiosGuid})

			# No host found for the SMBIOS guid
			if ($myhost -eq $null)
			{
			    $empty="Empty"
				$returnjson="Guid:"+$empty+",BMCAddress:"+$empty+",BMCType:"+$empty+",MarkedForDeletion:"+$empty+",ComputerName:"+$empty+",FQDN:"+$empty+",OperatingSystem:"+$empty+",OperatingSystemVersion:"+$empty+",HostCluster:"+$empty+",VMHostGroup:"+$empty
				$returnval = $returnval + "SUCCESS"
				$returnval = $returnval + $returnjson
				

				if ($debug1 -eq 0)
				{
					write-host "No Host found for the SMBIOS guid"
					write-host "Returning from GetHostBySMBIOS : " +$returnval
				}
								
				return $returnval

			}else {
				# Host found for the SMBIOS guid return some 
				#return $myhost.PhysicalMachine
				#$returnval = $returnval + "Host Found in SCVMM succesfully"
				#$returnval = $returnval + $myhost.PhysicalMachine.SMBiosGUID.Guid
				#$returnval = $returnval + $myhost.PhysicalMachine.BMCAddress
				#$returnval = $returnval + $myhost.PhysicalMachine.BMCType
				#$returnval = $returnval + $myhost.PhysicalMachine.MarkedForDeletion
				#$returnval = $returnval + $myhost.ComputerName
				#$returnval = $returnval + $myhost.FullyQualifiedDomainName
				#$returnval = $returnval + $myhost.OperatingSystem
				#$returnval = $returnval + $myhost.OperatingSystemVersion
				#$returnval = $returnval + $myhost.HostCluster 
				#$returnval = $returnval + $myhost.VMHostGroup 
				
				$returnjson="Guid:"+$myhost.PhysicalMachine.SMBiosGUID.Guid+",BMCAddress:"+$myhost.PhysicalMachine.BMCAddress+",BMCType:"+$myhost.PhysicalMachine.BMCType+",MarkedForDeletion:"+$myhost.PhysicalMachine.MarkedForDeletion+",ComputerName:"+$myhost.ComputerName+",FQDN:"+$myhost.FullyQualifiedDomainName+",OperatingSystem:"+$myhost.OperatingSystem+",OperatingSystemVersion:"+$myhost.OperatingSystemVersion+",HostCluster:"+$myhost.HostCluster+",VMHostGroup:"+$myhost.VMHostGroup
				$returnval = $returnval + "SUCCESS"
				$returnval = $returnval + $returnjson
				if ($debug1 -eq 0)
				{
					write-host "Returning from GetHostBySMBIOS : " +$returnval
				}
				write-host "Host Found in SCVMM successfully"
				write-host "Server discovered successfully"
				return $returnval
			}
		}catch [exception]
		{
				$returnval = $returnval + "FAIL"
				$returnval = $returnval + $Error[0].Exception
				write-host "Discovery of server failed"

				if ($debug1 -eq 0)
				{
					write-host "Returning from GetHostBySMBIOS : " +$returnval
				}
				return $returnval
		}

}