param($ComputerName,$DomainUsername,$DelPwd,$tejasFQDN,$info)
<# For Unit Test
$ComputerName="s2dscvmm2.s2d.com"
$DomainUsername="s2d1\Administrator"
$DelPwd="Dell_123$"
#>

$returnval = @()

###################### FUNCTIONS #############################

# Create Credetial Object 
Function Createcredobj($username, $passwd)
{

    try
    {
		$secpasswd = ConvertTo-SecureString  $passwd -AsPlainText -Force
        $mycredsobj = New-Object System.Management.Automation.PSCredential ($username, $secpasswd)
        #$Error
    }
    catch
    {
        $mycredsobj = $null
    }

    return $mycredsobj

}

###################### FUNCTIONS #############################

#import SCVMM related cmdlets
import-module virtualmachinemanager


try{
	write-host "connecting to the SCVMM "$ComputerName
	$cred= Createcredobj $DomainUsername $DelPwd
	$vmm=Get-SCVMMServer -ComputerName $ComputerName -Credential $cred
	
	if($vmm -ne $null){
		write-host "Connection to "$ComputerName " successfull, Now fetching the Logical Switches"
		$logicalSwitches= Get-SCLogicalSwitch -VMMServer $vmm
		write-host "switches found "$logicalSwitches
		
		$switchNames=""
		forEach($switch in $logicalSwitches){
			#write-host "Name: "$switch.Name
			$switchNames=$switchNames+$switch.Name+";"
		}
				
		$returnJson="Status:Got switches name,Switches:"+$switchNames
		$returnval=$returnval+ "SUCCESS"
		$returnval=$returnval+$returnJson
		
	}else{
		write-host "No SVMM exists on this system"
		$errmsg="Failed to connect to SCVMM"
		$returnval=$returnval+ "FAIL"
		$returnval=$returnval+$errmsg
	}
	return $returnval
}catch{
	write-host "Exception occured "
	$errmsg="Exception Occured"+$_.Exception.Message
	$returnval=$returnval+ "FAIL"
	$returnval=$returnval+$errmsg
	
	return $returnval
}