param($ComputerName,$DomainUsername,$DelPwd,$tejasFQDN,$tejasIP)

# Return Value
$returnval = @()
$temp = @("null") 
$userRoleList = @()
$userRoleString = ''  

#$DelUserName='tejas\administrator'
#$DelPwd='Dell_123$'
#$VMMServer='scvmm'
#$UserName = 'Enterprise Admins'

# Create obj
Function Createcredobj($username, $passwd)
{

    try
    {
		$secpasswd = ConvertTo-SecureString  $passwd -AsPlainText -Force
        $mycredsobj = New-Object System.Management.Automation.PSCredential ($username, $secpasswd)
        #$Error
    }
    catch
    {
        $mycredsobj = $null
    }

    return $mycredsobj

}

#import SCVMM related cmdlets
import-module virtualmachinemanager

# Create SCVMM Cred obj    
    $scvmmcreds = Createcredobj $DomainUsername $DelPwd
    if ( $scvmmcreds -eq $null)
    {
        $returnval = $returnval + "FAIL"
		$returnval = $returnval + "Could not create credential object for the given SCVMM user"
        return $returnval
    }


    try 
    {
        $VMMobj = Get-SCVMMServer -ComputerName $ComputerName -Credential $scvmmcreds 
    }
    catch [exception]
    {
        $returnval = $returnval + "FAIL"
		$returnval = $returnval + $Error[0].Exception
		return $returnval
    }

     if ( $VMMobj -eq $null)
    {
        $returnval = $returnval + "FAIL"
        $returnval = $returnval + " SCVMM host not reachable"
		return $returnval
       
    }
	else
    {

		try
		{
            $userRole = Get-SCUserRoleMembership -UserName $DomainUsername
			$userRoleList = $userRole.UserRoleProfile
            if ($userRoleList -eq $null)
            {
                $returnval = $returnval + "FAIL"
				$returnval = $returnval + "Unable to get Roles for the specified User"
				write-host "Unable to get Roles for the specified User"
				write-host "Returning from GetUserRole : : " +$returnval
                return $returnval
            }

               	$returnval = $returnval + "SUCCESS"
				
                foreach ($element in $userRoleList) {
	                $userRoleString = $userRoleString + $element +',' + ' '
                        }
               $userRoleString = $userRoleString.Substring(0,$userRoleString.Length-2)
               $jsonresponse="UserRole:"+$userRoleString
               $returnval = $returnval + $jsonresponse
	           write-host "Get roles for the specified user successfully"
			   write-host "Returning from GetUserRole : : " +$returnval
                return  $returnval
        }
        catch
        {
                $returnval = $returnval + "FAIL"
				$returnval = $returnval + $Error[0].Exception
				write-host "Get roles for the specified user failed"
				write-host "Returning from GetUserRole : " +$returnval
				return $returnval
        }


    }


