param($ComputerName,$DomainUsername,$DelPwd,$tejasFQDN,$tejasIP)

#$SVMMServer = $name
#$DelUserName = "delldemo\administrator"
#$DelPwd = Get-Credential -Credential $SCVMMAdminUser
#$TejasFQDN = "tejas.com"


# Create obj
Function Createcredobj($username, $passwd)
{

    try{
        $secpasswd = ConvertTo-SecureString  $passwd -AsPlainText -Force
        $mycredsobj = New-Object System.Management.Automation.PSCredential ($username, $secpasswd)
        #$Error
    }
    catch
    {
        # handling of exception and returning back is having some issues 
        #$errorMessage = $Error[0].exception
        if ($debug1 -eq 0)
        {
            write-host "inside catch"
        }
    }

    return $mycredsobj

}

$returnValue = @()

try 
{
	#import SCVMM related cmdlets
	import-module virtualmachinemanager

	$Credential = Createcredobj $DomainUsername $DelPwd
	$VMMobj = Get-SCVMMServer $ComputerName -Credential $Credential


	if ( $VMMobj -eq $null)
	{
		$reurnjson="Status:Could be because of not able to get local host FQDN or Integration Gateway failure."
		$returnValue = $returnValue + "FAIL" 
		$returnValue = $returnValue + $returnjson
		
	}
	else
	{
		#Application profile name and Description
		$appProfileName = "OMIMSSC SCVMM Console Extension Registration Profile"
		$appProfileDescription = "*DO NOT DELETE* This is auto generated and used by OpenManage Integrations for Microsoft System Center. OMIMSSC SCVMM Console Extension will not work if you delete this profile."
		
		$isAppProfile = Get-SCApplicationProfile -Name  $appProfileName -VMMServer $VMMobj 
		#Get-SCApplicationProfile -Name "OMIMSSC SCVMM Console Extension Registration Profile"  -VMMServer $VMMobj 
		if($isAppProfile -eq $null)
		{
		   $AppProfile = New-SCApplicationProfile -Name $appProfileName -Description $appProfileDescription -VMMServer $VMMobj 
		   if($AppProfile -eq $null)
		   {
				$reurnjson="Status:Could Not creat DLCI application profile. Check if the user has required credentials to create application profile.,Code:-1"
				$returnValue = $returnValue + "FAIL" 
				$returnValue = $returnValue + $reurnjson
				
		 }
		   else
		   {
			   $ScriptSetting = New-SCScriptCommandSetting 
			   Add-SCScriptCommand -ApplicationProfile $AppProfile -Executable "cmd /c echo" -ScriptType "PreInstall" -CommandParameters $tejasFQDN| out-null
       
			   	$returnjson="Status:Successfully registered with VMM server"
				write-host "Successfully registered with VMM server"
		    	$returnValue = $returnValue + "SUCCESS" 
				$returnValue = $returnValue + $returnjson
			   
		   }

		}
		else
		{
			$reurnjson="Status:Delete the DLCI Application Profile from Library of SCVMM server and try again,Code:-2"
			$returnValue = $returnValue + "FAIL" 
			$returnValue = $returnValue + $reurnjson
			
		}
	}
}
catch [system.exception]
            {
            		$reurnjson="Status:"+$_.Exception.Message
		    		$returnValue = $returnValue + "FAIL" 
					$returnValue = $returnValue + $reurnjson
                    write-host "Registration with VMM server failed"
            }
write-host "Returning from RegisterSCVMM: " +$returnValue
return $returnValue
