param(
    [string]$metricsHash
  )
try
{
    Write-Host $metricsHash
    if($metricsHash.Contains(";"))
    {
    $metricsHashAr = $metricsHash.split(";")
    }
    else
    {
    $metricsHashAr = @($metricsHash)
    }
    Write-Host $metricsHashAr.Length
    For($i=0;$i -lt $metricsHashAr.Length;$i++)
    {
       
        $metrics_components = $metricsHashAr.Get($i).split(",")
       
        if($metrics_components.length -eq 5)
        { 

            $EventID = $metrics_components.Get(0)
            Write-Host $EventID
            $PreviousCycleMetricsData = $metrics_components.Get(1)
            $CurrentCycleMetricsData = $metrics_components.Get(2)
            $InstanceIndex = $metrics_components.Get(3)
            $ServerID = $metrics_components.Get(4)
            if([System.Diagnostics.EventLog]::SourceExists("Dell Appliance") -eq $false)
            {
                New-EventLog -Source "Dell Appliance" -LogName "Operations Manager"
            }
            
            $EventType = "Information"

            $AlertMessage = "$PreviousCycleMetricsData" + "\" + "$CurrentCycleMetricsData" + "\" + $ServerID + "\" + $InstanceIndex 

            Write-EventLog -LogName "Operations Manager" -Source "Dell Appliance" -EventID $EventID -EntryType $EventType  -Message $AlertMessage  

            sleep 1
           
                 
        }
        else
        {
           return "FAIL";
        }
    }
}
catch [Exception]
 {
   return "FAIL";
 }
