param($ComputerName,$DomainUsername,$DelPwd,$tejasFQDN,$SccmSmBiosGuid)

#$ComputerName="sccmsharu1.mydomain.com"
#$DomainUsername="MYDOMAIN\Administrator"
#$tejasFQDN="build1034.mydomain.com"
#$SccmSmBiosGuid="2W43F02,2W43F02,MINWINPC,PowerEdge\n\rR720,44454c4c-5700-1034-8033-b2c04f463032,4c4c4544-0057-3410-8033-b2c04f463032,F8:BC:12:3E:F3:32?F8:BC:12:3E:F3:33?F8:BC:12:3E:F3:30?F8:BC:12:3E:F3:31?,255.255.255.128,Unknown,Unknown,100.96.34.16"


Function Createcredobj($username, $passwd){
    try{
		$secpasswd = ConvertTo-SecureString  $passwd -AsPlainText -Force
        $mycredsobj = New-Object System.Management.Automation.PSCredential ($username, $secpasswd)
        #$Error
    }
    catch{
        $mycredsobj = $null
    }

    return $mycredsobj
}



$SccmSmBiosGuid = $SccmSmBiosGuid -replace "\\n\\r", " "


$returnval = @()


$sccmCred= Createcredobj $DomainUsername $DelPwd
$emsg=@()
try{
	$emsg=Invoke-Command -ComputerName $ComputerName -Credential $sccmCred -ConfigurationName Microsoft.PowerShell32 -ScriptBlock{
    
   	
	############### CONSTANTS ###########################
	
	set-variable -name Response_Success -value "SUCCESS" -option constant
	set-variable -name Response_FAIL -value "FAIL" -option constant
	set-variable -name Exception_Code -value 101 -option constant
	set-variable -name zeroguid -value "00000004-0000-0000-0000-000000000000" -option constant
	set-variable -name collectionNameAllSystems -value "All Systems" -option constant
	set-variable -name osNameVersionIndex -value "0,1,2,3,4,5,6,7,8,9" -option constant
	set-variable -name collectionNameImportDellServers -value "Dell Imported Servers" -option constant
	set-variable -name collectionNameAllDellLCControllers -value "All Dell Lifecycle Controller Servers" -option constant
	set-variable -name collectionCommentImportDellServers -value "All Dell PowerEdge servers discovered using Import Dell PowerEdge servers wizard" -option constant
	set-variable -name collectionCommentAllDellLCControllers -value "All Dell PowerEdge servers" -option constant
	set-variable -name collectionNameRhel -value "managed dell lifecycle controller(rhel)" -option constant
	set-variable -name collectionNameEsxi -value "managed dell lifecycle controller(esxi)" -option constant
	set-variable -name osRhel -value "rhel" -option constant
	set-variable -name osEsxi -value "esxi" -option constant
	set-variable -name collectionCommentAllDellLCControllers -value "All Dell PowerEdge servers" -option constant
	
	############### CONSTANTS ###########################
	
	############## FUNCTIONS ############################
	
	Function isExistingHost($hostnameparam,$nsparam){

		$deployedOSList= @()
		#$isall=isHostPresentInCollection $hostnameparam $nsparam
		

		$doescollectionexist=$false
		#check if the host is present in Collection All system $collectionNameAllSystems
		$query="Select * from SMS_Collection WHERE Name='$collectionNameAllSystems'"

		$responses=Get-WMIObject -Query $query -Namespace $nsparam
		
		if(($responses -ne $null)){
			#the collection exists
			$doescollectionexist= $true
		}
		
		$collectionId=""
		if($doescollectionexist -eq $true){
			#get the collection id
			$query="Select CollectionID from SMS_Collection WHERE Name='$collectionNameAllSystems'"
			$responses=Get-WMIObject -Query $query -Namespace $nsparam

			
			if(($responses -ne $null)){

				foreach($response in $responses){

					$collectionId=$response.CollectionID
				}
			}
		}
		

		$hostinCollectionExist=$false
		if(![string]::IsNullorEmpty($collectionId)){
			$query="SELECT * FROM SMS_FullCollectionMembership WHERE CollectionID = '$collectionId'"
			$responses=Get-WMIObject -Query $query -Namespace $nsparam
      
			
			if(($responses -ne $null)){
				foreach($response in $responses){
					if($hostnameparam -match $response.Name){
						$hostinCollectionExist=$true
						break
					}
				}
			}
		}
		
		$isall= $hostinCollectionExist


		if($isall -eq $true){
			$query="Select * from SMS_R_SYSTEM WHERE NETBIOSNAME='$hostnameparam'"
			$responses=Get-WMIObject -Query $query -Namespace $nsparam
		
   
			if(($responses -ne $null)){
				foreach($row in $responses){
                
                    $collectionName=(getAllCollection $hostnameparam $nsparam)
                    

					if($row.Client -eq "1"){	
						#if the client is installed 
						if(![string]::IsNullOrEmpty($row.OperatingSystemNameandVersion)){
							$index=0
							#get the index from which the version starts in OperatingSystemNameandVersion from WMI
							foreach($versionIndex in $osNameVersionIndex){
								if($row.OperatingSystemNameandVersion -match $versionIndex){
									$tempindex=$row.OperatingSystemNameandVersion.IndexOf($versionIndex)
								}
								if($tempindex -lt $index -or $index -eq 0){
									$index=$tempindex
								}
							}
				
							$oname=$row.OperatingSystemNameandVersion.SubString(0,$index)
							$oversion=$row.OperatingSystemNameandVersion.SubString($index)
							#$collectionName=(getAllCollection $hostnameparam $nsparam)
							
							$deployedOSList=$deployedOSList+@($row.SMBIOSGUID,$row.IPAddresses,$row.Name,"",$oname,$oversion)
						}
					}else{
						#For Non OS host, get the OS Name from iDrac
						$queryIdrac="Select * from SMS_R_iDRAC where NetbiosName = '$hostnameparam'"
						$resultIdrac=Get-WMIObject -Query $queryIdrac -Namespace $nsparam
			
   
						foreach($singleResult in $resultIdrac){
							if(![string]::IsNullOrEmpty($singleResult.OSName)){
								#$collectionName=(getAllCollection $hostnameparam $nsparam)
                                
								if(($singleResult.OSName.ToLower() -match $osRhel) -or ($singleResult.OSName.ToLower() -match $osEsxi)){
					
									$deployedOSList=$deployedOSList+@($row.SMBIOSGUID,$row.IPAddresses,$row.Name,"",$singleResult.OSName,"")
								}
							}
						}
					}
				}
			}
		}else{
    
			return $null
		}

    return $deployedOSList
    }
	
	
	Function getAllCollection ($hostnameparam,$nsparam){

		$collList=@()
		$collectionList=""
		$queryColl="select SC.Name from SMS_Collection SC join SMS_FullCollectionMembership SFCM on SC.CollectionID = SFCM.CollectionID Where SFCM.Name = '$hostnameparam'"
		$resultColl=Get-WMIObject -Query $queryColl -Namespace $nsparam
	
		foreach($coll in $resultColl){
			$collList=$collList+$coll.Name
		}
	
		foreach($col in $collList){
			if($col -eq $collectionNameImportDellServers){
				$isImpoterdDellColExist=true
			}
		
			if($col -eq $collectionNameAllDellLCControllers){
				$isAllDellColExist=true
			}
		
			$collectionList=$collectionList+$col+"&"
		}
	
		if(!$isImpoterdDellColExist){
			$collectionList=$collectionList+$collectionNameImportDellServers+"&"
		}
		if(!$isAllDellColExist){
			$collectionList=$collectionList+$collectionNameAllDellLCControllers+"&"
		}
	
		$list=$collectionList.SubString(0,$collectionList.Length-1)
	
		return $list
	}
	
	############## FUNCTIONS ############################
	
	#Step 1. create objects from smbios guid
        		
		$nodeId=$args[2].split(",")[0]
		$serviceTag=$args[2].split(",")[1]
		$hostname=$args[2].split(",")[2]
		$model=$args[2].split(",")[3]
		$guid=$args[2].split(",")[4]
		$platformGuid=$args[2].split(",")[5]
		$macAddress=$args[2].split(",")[6].split("?")
		$ipsubnet=$args[2].split(",")[7]
		$osnames=$args[2].split(",")[8].split(":")
		$driverpackversion=$args[2].split(",")[9]
		$ipaddresses=$args[2].split(",")[10]
		$nonWindowsOSDeployed=$args[2].split(",")[11]
		
        
		#Step 2. Get the Site Code
        Import-Module -Name "$(split-path $Env:SMS_ADMIN_UI_PATH)\ConfigurationManager.psd1"
	   	$PSD = Get-PSDrive -PSProvider CMSite
	    if($PSD -eq $null){
			New-PSDrive -Name "LOCAL" -PSProvider CMSite -Root $args[1]
			$PSDN = Get-PSDrive -PSProvider CMSite -Name "LOCAL"
			$SiteCode= CD "$($PSDN):"
		}else{
	        $SiteCode= CD "$($PSD):"	
		}
	    $VMMobj= Get-CMSite
        if ( $VMMobj -ne $null ){
			
			$site=$VMMobj.SiteCode
	    }else{
			return "Site Code of the SC was not identified"
		}
		$ns="root\sms\site_$site"
		
		#Step 3. Create DDRs
		#modify host using DDR For Import Dell Servers
		
		$EmptyQueryResult=$true
		
		$queryString="SELECT * from SMS_R_System WHERE NetbiosName='$hostname'"
		$queryResult=Get-WMIObject -Query $queryString -Namespace $ns
		$resourceNames=@('Dell iDRAC')
                 
		if($queryResult -ne $null){
			$EmptyQueryResult=$false
		
			foreach($res in $queryResult){
                         
    
                #load the dll
                #  & regsvr32.exe 'C:\Program Files (x86)\Microsoft Configuration Manager\AdminConsole\XmlStorage\Extensions\DLCPlugin\Interop.SMSRSGENCTLLib.dll'
                          
				#create the COM Object
				$SMSDisc = New-Object -ComObject SMSResGen.SMSResGen.1
	
				#Specify the Architecture, Name for the DDR and the SiteCode
				$SMSDisc.DDRNew("System","CustomAgent",$site)
	
				#Add the String Property Netbios Name - (Propertyname,Value,Width,DiscoveryFlag specifying that it is Key[Hex Value])
				$SMSDisc.DDRAddString("Netbios Name", $hostName, 64, 0x8)
	
				#Add the String Array Property IP addresses - (Propertyname,Value,Width,DiscoveryFlag specifying it is an Array)
				$SMSDisc.DDRAddStringArray("MAC Addresses", $macAddress, 64, 0x10)
				
				#Get the DDR Path from WMI
				$ddrInboxPath=""
				$getDDRQuery="SELECT DDRPath from SMS_Dell_OOBConfig_Settings WHERE ResourceID=1"
				$resultsGetDDR=Get-WMIObject -Query $getDDRQuery -Namespace "root\cimv2\dlci"
	
    
				if($resultsGetDDR -ne $null){
					foreach($resultGetDDR in $resultsGetDDR){
						$ddrInboxPath=$resultGetDDR.DDRPath
					}
				}
	
				if($ddrInboxPath.Length -eq 0){
					$ddrInboxPath =$ddrInboxPath+ "\\{0}"
				}
				$desktopPath="C:\$hostname.DDR" 
    
                $fileddrPath= join-path $ddrInboxPath "$hostname.DDR"
				
				
				#save the DDR to the Path
				$wasDDRCreated=$SMSDisc.DDRWrite($desktopPath)
				$SMSDisc.DDRWrite($fileddrPath)
    
                #now copy this DDR file to your SCCM Server DDM.Box inbox 
                Copy-Item -path $desktopPath -Destination $fileddrPath -Verbose								
    
				$SMSDisc.DDRNew("iDRAC","CustomAgent",$site)
				$SMSDisc.DDRAddString("Netbios Name", $hostName, 64, 0x8)
				$SMSDisc.DDRAddString("ProvisioningMethod", "Discovered", 64, 0x8)
				$SMSDisc.DDRAddString("Computer Name", $hostName, 64, 0x8)
				$SMSDisc.DDRAddString("Service Tag", $serviceTag, 64, 0x8)
				$SMSDisc.DDRAddString("Node ID", $nodeId, 64, 0x8)
				$SMSDisc.DDRAddStringArray("Resource Names", $resourceNames, 64, 0x10)
				$SMSDisc.DDRAddString("Description", "Dell iDRAC", 64, 0x8)
				$SMSDisc.DDRAddString("IP Addresses", $ipaddresses, 64, 0x8)
				$SMSDisc.DDRAddString("SMBIOS GUID", $guid, 64, 0x8)
				$SMSDisc.DDRAddString("Model",$model, 64, 0x8)
				$SMSDisc.DDRAddString("CustomCollectionName", $customcollectionqueryid, 64, 0x8)
				$SMSDisc.DDRAddString("IP Subnets", $ipsubnet, 64, 0x8)
				$SMSDisc.DDRAddStringArray("MAC Addresses", $macAddress, 64, 0x10)
				if($nonWindowsOSDeployed.ToLower() -match $osRhel -or $nonWindowsOSDeployed.ToLower() -match $osEsxi){
					$SMSDisc.DDRAddString("OSName", $nonWindowsOSDeployed, 64, 0x8)
                             
				}else{
					$SMSDisc.DDRAddString("OSName", "", 64, 0x8)
				}
				
				if($osnames -eq $null -or $osnames.Length -eq 0){
				
					$SMSDisc.DDRAddString("Driver Pack Version", "Unknown", 64, 0x8)
					
				}else{
					$SMSDisc.DDRAddString("Drivers Available For", $osnames, 64, 0x8)
					
					if([string]::IsNullOrEmpty($driverpackversion)){
					
						$SMSDisc.DDRAddString("Driver Pack Version", "Unknown", 64, 0x8)
						
					}else{
						$SMSDisc.DDRAddString("Driver Pack Version", $driverpackversion, 64, 0x8)
					}
				}
				
				$idracOutDdrName= "Idrac-"+$hostname+".DDR"
    
                $desktopPath="C:\$idracOutDdrName"
    
                $fileddrPath= join-path $ddrInboxPath $idracOutDdrName
				
				  									
				#save the DDR to the Path
				$wassecondddr=$SMSDisc.DDRWrite($desktopPath)
				$SMSDisc.DDRWrite($fileddrPath)
				
                #now copy this DDR file to your SCCM Server DDM.Box inbox 
                Copy-Item -path $desktopPath -Destination $fileddrPath -Verbose
			}
		}
		if($EmptyQueryResult){
			#If we reach here then it means that the ImportMachineEntry SCCM call did not add the system with 
			#this Netbiosname. One of the reason is because the system with the same SMBIOSGUID already exists  
			#in SMS_R_SYSTEM with a different hostname
			
			#Since an entry is in SCCM with hostname (other than svctag), create iDRAC DDR and copy to ddm box
			#create the COM Object
			$SMSDisc = New-Object -ComObject SMSResGen.SMSResGen.1
    
			$SMSDisc.DDRNew("iDRAC","CustomAgent",$site)
			$SMSDisc.DDRAddString("Netbios Name", $hostName, 64, 0x8)
			$SMSDisc.DDRAddString("ProvisioningMethod", "Discovered", 64, 0x8)
			$SMSDisc.DDRAddString("Computer Name", $hostName, 64, 0x8)
			$SMSDisc.DDRAddStringArray("Resource Names", $resourceNames, 64, 0x10)
			$SMSDisc.DDRAddString("Description", "Dell iDRAC", 64, 0x8)
			$SMSDisc.DDRAddString("IP Addresses", $ipaddresses, 64, 0x8)
			$SMSDisc.DDRAddString("SMBIOS GUID", $guid, 64, 0x8)
			$SMSDisc.DDRAddString("Model",$model, 64, 0x8)
			$SMSDisc.DDRAddString("CustomCollectionName", $customcollectionqueryid, 64, 0x8)
			$SMSDisc.DDRAddString("IP Subnets", $ipsubnet, 64, 0x8)
			$SMSDisc.DDRAddStringArray("MAC Addresses", $macAddress, 64, 0x10)
			$SMSDisc.DDRAddString("OSName", "", 64, 0x8)
									
			if($osnames -eq $null -or $osnames.Length -eq 0){
			
				$SMSDisc.DDRAddString("Driver Pack Version", "Unknown", 64, 0x8)
				
			}else{
				$SMSDisc.DDRAddString("Drivers Available For", $osnames, 64, 0x8)
				
				if([string]::IsNullOrEmpty($driverpackversion)){
				
					$SMSDisc.DDRAddString("Driver Pack Version", "Unknown", 64, 0x8)
					
				}else{
					$SMSDisc.DDRAddString("Driver Pack Version", $driverpackversion, 64, 0x8)
				}
			}
			
			#Get the DDR Path from WMI
			$ddrInboxPath=""
			$getDDRQuery="SELECT DDRPath from SMS_Dell_OOBConfig_Settings WHERE ResourceID=1"
			$resultsGetDDR=Get-WMIObject -Query $getDDRQuery -Namespace "root\cimv2\dlci"
	        
            
			if($resultsGetDDR -ne $null){
				foreach($resultGetDDR in $resultsGetDDR){
					$ddrInboxPath=$resultGetDDR.DDRPath
				}
			}
	        
			if($ddrInboxPath.Length -eq 0){
				$ddrInboxPath =$ddrInboxPath+ "\\{0}"
			}
			
			$idracOutDdrName= "Idrac-"+$hostname+".DDR"
			$desktopPath="C:\$idracOutDdrName"
     							
            $fileddrPath= join-path $ddrInboxPath $idracOutDdrName
			
			  									
			#save the DDR to the Path
			$wassecondddr=$SMSDisc.DDRWrite($desktopPath)
			$SMSDisc.DDRWrite($fileddrPath)
                        
            #now copy this DDR file to your SCCM Server DDM.Box inbox 
            Copy-Item -path $desktopPath -Destination $fileddrPath -Verbose
			
		}
		
		#Step4. Create Collections
		
		$retCode=$false	
		#check if the collection Dell Imported Servers exist
		$collName=$collectionNameImportDellServers
		
		$collName=$collName.Replace("\","\\")
		$collName=$collName.Replace("'","\'")
		
		$queryString="Select * from SMS_Collection WHERE Name='$collName'"
		$collResult=Get-WMIObject -Query $queryString -Namespace $ns
		
		if($collResult -ne $null){
		
			$retCode=$true
		}
		#if the collection exists nothing is performed, else we create the collection
		if(!$retCode){
		
			#$errMsg=CreateCollectionsForImportDellServers $collectionNameImportDellServers $ns $siteCode
			#check if the collection Dell Lifecycle Controller collection
			$queryString="Select * from SMS_Collection WHERE Name='$collectionNameAllDellLCControllers'"
			$collResult=Get-WMIObject -Query $queryString -Namespace $ns
				
			if(($collResult -ne $null)){
				#the collection exists, create only Dell Imorted Servers
				foreach($row in $collResult){
					$parentColl=$row.CollectionID
				}
				
				if(![string]::IsNullorEmpty($parentColl)){
					#Create collection Dell Imported Servers
					$limitToCollectionID="SMS00001"
					$ownedByThisSite=$true
					$query="Select * from SMS_R_SYSTEM Inner join SMS_R_iDRAC ON  (SMS_R_SYSTEM.SMBIOSGUID=SMS_R_iDRAC.SMBIOSGUID OR SMS_R_SYSTEM.NETBIOSNAME=SMS_R_iDRAC.NETBIOSNAME) WHERE SMS_R_iDRAC.ProvisioningMethod= \""Discovered\"""
					$ruleName= "11G_Dell_Import_Servers"
					$validateQuery=$true
					
					#create new SMS_Collection object
					$CMCollection = ([WMIClass]"\\.\root\SMS\Site_$($site):SMS_Collection").CreateInstance()
					$CMCollection.Name=$collectionNameImportDellServers
					$CMCollection.Comment=$collectionCommentImportDellServers
					$CMCollection.OwnedByThisSite=$ownedByThisSite
					$CMCollection.LimitToCollectionID=$limitToCollectionID
					$didCommit=$CMCollection.Put()
					
					#validate
					if($validateQuery -eq $true){
						#Validate Query syntax  
						$ValidatingQuery = Invoke-WmiMethod -Namespace $ns -Class SMS_CollectionRuleQuery -Name ValidateQuery -ArgumentList $query
						if($ValidatingQuery -eq $null){
							return "Status:$response_FAIL,Message:Validation of query failed"
						}
					}
					
					#create new Query Rule 
					$NewRule = ([WMIClass]"\\.\Root\SMS\Site_$($site):SMS_CollectionRuleQuery").CreateInstance()
					$NewRule.QueryExpression=$query
					$NewRule.RuleName=$ruleName
					

					#Commit changes and initiate the collection evaluator                   
					$isAdded=$CMCollection.AddMemberShipRule($NewRule) 


					if($isAdded.ReturnValue -eq 0){
						$CMCollection.RequestRefresh()
						$retCode=$true
						
					}else{
						return "Status:$response_FAIL,Message:Unable to add membership rule for collection"
					}
				}
			}else{
				#The collections Dell Lifecycle Controller does not exist, so we create the Collection
				$retCode = $false
				$parentColl = ""
				$queryString = "Select * from SMS_R_iDRAC"
				$collFound = $false
				$MAXRETRIES = 10
				$ctr = 0
		
		
				while($ctr -lt $MAXRETRIES -and $collFound -eq $false){
					$ctr=$ctr+1
				
					$result=Get-WMIObject -Query $queryString -Namespace $ns
									
					if($result -ne $null)
					{
						$collFound = $true
					}
				

					#CreateDynamicCollectionForSCCM2012
					$limitToCollectionID="SMS00001"
					$ownedByThisSite=$true
					$query="Select * from SMS_R_SYSTEM Inner join SMS_R_iDRAC ON (SMS_R_SYSTEM.SMBIOSGUID=SMS_R_iDRAC.SMBIOSGUID OR SMS_R_SYSTEM.NETBIOSNAME=SMS_R_iDRAC.NETBIOSNAME)"
					$ruleName= "11G_Parent_Rule"
					$validateQuery=$true
					$retCode=$false
					
					#create new SMS_Collection object
					$CMCollection = ([WMIClass]"\\.\root\SMS\Site_$($site):SMS_Collection").CreateInstance()
					$CMCollection.Name=$collectionNameAllDellLCControllers
					$CMCollection.Comment=$collectionCommentAllDellLCControllers
					$CMCollection.OwnedByThisSite=$ownedByThisSite
					$CMCollection.LimitToCollectionID=$limitToCollectionID
					$didCommit=$CMCollection.Put()
		
					#validate
					if($validateQuery -eq $true){
						#Validate Query syntax  
						$ValidatingQuery = Invoke-WmiMethod -Namespace $ns -Class SMS_CollectionRuleQuery -Name ValidateQuery -ArgumentList $query
						if($ValidatingQuery -eq $null){
							return "Status:$response_FAIL,Message:Validation of query failed"
						}
					}
					
					#create new Query Rule 
					$NewRule = ([WMIClass]"\\.\Root\SMS\Site_$($site):SMS_CollectionRuleQuery").CreateInstance()
					$NewRule.QueryExpression=$query
					$NewRule.RuleName=$ruleName
					

					#Commit changes and initiate the collection evaluator                   
					$isAdded=$CMCollection.AddMemberShipRule($NewRule) 


					if($isAdded.ReturnValue -eq 0){
						$CMCollection.RequestRefresh()
						$retCode=$true
						
					}else{
						return "Status:$response_FAIL,Message:Unable to add membership rule for collection"
					}
	
					#Now Creating DEll Import Servers
			
					if($retCode -eq $true){
						#get Collection ID
						$queryCollectionId="Select CollectionID from SMS_Collection WHERE Name='$collectionNameAllDellLCControllers'"
						$collectionID=Get-WMIObject -Query $queryCollectionId -Namespace $ns
						

						if($collectionId -eq $null){
							return "Unable to retrieve collection ID for Name='$collectionNameAllDellLCControllers'"
						}else{
							foreach($id in $collectionId){
								$parentColl=$id.CollectionID
							}
						}
						

						if(![string]::IsNullOrEmpty($parentColl)){
							if($true)#if liscence is true
							{
								$valQuery="Select * from SMS_R_SYSTEM Inner join SMS_R_iDRAC ON  (SMS_R_SYSTEM.SMBIOSGUID=SMS_R_iDRAC.SMBIOSGUID OR SMS_R_SYSTEM.NETBIOSNAME=SMS_R_iDRAC.NETBIOSNAME) WHERE SMS_R_iDRAC.ProvisioningMethod= \""Discovered\"""
								$ruleName="11G_Dell_Import_Servers"
								
								$newRetCode=$false
								
								#create new SMS_Collection object
								$CMCollection = ([WMIClass]"\\.\root\SMS\Site_$($site):SMS_Collection").CreateInstance()
								$CMCollection.Name=$collectionNameImportDellServers
								$CMCollection.Comment=$collectionCommentImportDellServers
								$CMCollection.OwnedByThisSite=$ownedByThisSite
								$CMCollection.LimitToCollectionID=$parentColl
								$CMCollection.Put() 
								
								#validate
								if($validateQuery){
									#Validate Query syntax  
									$Val = Invoke-WmiMethod -Namespace $ns -Class SMS_CollectionRuleQuery -Name ValidateQuery -ArgumentList $valQuery
									if($Val -eq $null){
										return "Status:$Response_FAIL,Message:Validation of query failed"
									}
								}
					
					
								#create new Query Rule 
								$NewRule = ([WMIClass]"\\.\Root\SMS\Site_$($site):SMS_CollectionRuleQuery").CreateInstance()
								$NewRule.QueryExpression=$valQuery
								$NewRule.RuleName=$ruleName
					
								#Commit changes and initiate the collection evaluator                   
								$isAdded=$CMCollection.AddMemberShipRule($NewRule)
								if($isAdded.ReturnValue -eq 0){
									$CMCollection.RequestRefresh() 
									$newRetCode=$true
						
								}else{
									return "Status:$Response_Fail,Message:Unable to add membership rule for collection"
								}
								
							}
						}
					}
				}
			}
		}
		
		#validating the new DDR created
		$isHostPresent=(isExistingHost $hostname $ns)
		$collectionName=(getAllCollection $hostname $ns)
      	
		$returnValue=@()
		# Map the return values the powershell to response object
		$returnValue="Status:$Response_Success"
		$returnJson="SMBiosGUID:$platformGuid,"
		if([string]::IsNullOrEmpty($isHostPresent[0])){
			$returnJson=$returnJson+"IdracIp:$null,"
		}else{
			$returnJson=$returnJson+"IdracIp:$ipaddresses,"
		}
		$returnJson=$returnJson+"Protocol:$null,MarkedForDeletion:NA,"
		if($isHostPresent[4] -match $osRhel -or $isHostPresent[4] -match $osEsxi){
			$returnJson=$returnJson+"HostName:$nonWindowsOSDeployed,"
		}else{
			if([string]::IsNullOrEmpty($isHostPresent[2])){
				$returnJson=$returnJson+"HostName:$null,"
			}else{
				$returnJson=$returnJson+"HostName:"+$isHostPresent[2]+","
			}
		}
		
		if([string]::IsNullOrEmpty($isHostPresent[3])){
			$returnJson=$returnJson+"FQDN:$null,"
		}else{
			$returnJson=$returnJson+"FQDN:"+$isHostPresent[3]+","
		}
		if([string]::IsNullOrEmpty($isHostPresent[4])){
			$returnJson=$returnJson+"OSName:$null,"
		}else{
			$returnJson=$returnJson+"OSName:"+$isHostPresent[4]+","
		}
		if([string]::IsNullOrEmpty($isHostPresent[5])){
			$returnJson=$returnJson+"OSVersion:$null,"
		}else{
			$returnJson=$returnJson+"OSVersion:"+$isHostPresent[5]+","
		}
		$returnJson=$returnJson+"ClusterFQDN:$null,"
		
		if([string]::IsNullorEmpty($collectionName)){
			$returnJson=$returnJson+"GroupName:$null"
		}else{
			$returnJson=$returnJson+"GroupName:"+$collectionName
		}
	
		$returnValue=$returnValue+$returnJson
	
		return $returnValue
		
	}-Args $DomainUsername,$ComputerName,$info -ErrorVariable errmsg  2>$null
	
	if ($emsg -match "FAIL"){
        $returnval=$returnval+"FAIL"
        $returnval=$returnval+$emsg
    }else{
        $returnval=$returnval+"SUCCESS"
        $returnval=$returnval+$emsg
    }
	return $returnval
	
}catch{
	$returnval=$returnval+"FAIL"
	$returnval=$returnval+$_.Exception.Message
	return $returnval
}