param($ComputerName,$DomainUsername,$DelPwd,$tejasFQDN,$SccmSmBiosGuid)

#$ComputerName="sccmsharu1.mydomain.com"
#$DomainUsername="MYDOMAIN\Administrator"
#$tejasFQDN="build1034.mydomain.com"
#$SccmSmBiosGuid="2W43F02,2W43F02,MINWINPC,PowerEdge\n\rR720,44454c4c-5700-1034-8033-b2c04f463032,4c4c4544-0057-3410-8033-b2c04f463032,F8:BC:12:3E:F3:32?F8:BC:12:3E:F3:33?F8:BC:12:3E:F3:30?F8:BC:12:3E:F3:31?,255.255.255.128,Unknown,Unknown,100.96.34.16"


Function Createcredobj($username, $passwd){
    try{
		$secpasswd = ConvertTo-SecureString  $passwd -AsPlainText -Force
        $mycredsobj = New-Object System.Management.Automation.PSCredential ($username, $secpasswd)
        #$Error
    }
    catch{
        $mycredsobj = $null
    }

    return $mycredsobj
}



$SccmSmBiosGuid = $SccmSmBiosGuid -replace "\\n\\r", " "


$returnval = @()


$sccmCred= Createcredobj $DomainUsername $DelPwd
$emsg=@()
try{
	$emsg=Invoke-Command -ComputerName $ComputerName -Credential $sccmCred -ConfigurationName Microsoft.PowerShell32 -ScriptBlock{
    
   	
	############### CONSTANTS ###########################
	
	set-variable -name Response_Success -value "SUCCESS" -option constant
	set-variable -name Response_FAIL -value "FAIL" -option constant
	set-variable -name Exception_Code -value 101 -option constant
	set-variable -name zeroguid -value "00000004-0000-0000-0000-000000000000" -option constant
	set-variable -name collectionNameAllSystems -value "All Systems" -option constant
	set-variable -name osNameVersionIndex -value "0,1,2,3,4,5,6,7,8,9" -option constant
	set-variable -name collectionNameImportDellServers -value "Dell Imported Servers" -option constant
	set-variable -name collectionNameAllDellLCControllers -value "All Dell Lifecycle Controller Servers" -option constant
	set-variable -name collectionCommentImportDellServers -value "All Dell PowerEdge servers discovered using Import Dell PowerEdge servers wizard" -option constant
	set-variable -name collectionCommentAllDellLCControllers -value "All Dell PowerEdge servers" -option constant
	set-variable -name collectionNameRhel -value "managed dell lifecycle controller(rhel)" -option constant
	set-variable -name collectionNameEsxi -value "managed dell lifecycle controller(esxi)" -option constant
	set-variable -name osRhel -value "rhel" -option constant
	set-variable -name osEsxi -value "esxi" -option constant
	set-variable -name collectionCommentAllDellLCControllers -value "All Dell PowerEdge servers" -option constant
	
	############### CONSTANTS ###########################
	
	############## FUNCTIONS ############################
	Function getAllCollection ($hostnameparam,$nsparam){

		$collList=@()
		$collectionList=""
		$queryColl="select SC.Name from SMS_Collection SC join SMS_FullCollectionMembership SFCM on SC.CollectionID = SFCM.CollectionID Where SFCM.Name = '$hostnameparam'"
		$resultColl=Get-WMIObject -Query $queryColl -Namespace $nsparam
	
		foreach($coll in $resultColl){
			$collList=$collList+$coll.Name
		}
	
		foreach($col in $collList){
			if($col -eq $collectionNameImportDellServers){
				$isImpoterdDellColExist=true
			}
		
			if($col -eq $collectionNameAllDellLCControllers){
				$isAllDellColExist=true
			}
		
			$collectionList=$collectionList+$col+"&"
		}
	
		if(!$isImpoterdDellColExist){
			$collectionList=$collectionList+$collectionNameImportDellServers+"&"
		}
		if(!$isAllDellColExist){
			$collectionList=$collectionList+$collectionNameAllDellLCControllers+"&"
		}
	
		$list=$collectionList.SubString(0,$collectionList.Length-1)
	
		return $list
	}
	
	############## FUNCTIONS ############################
	
	#Step 1. create objects from smbios guid
        		
		$nodeId=$args[2].split(",")[0]
		$serviceTag=$args[2].split(",")[1]
		$hostname=$args[2].split(",")[2]
		$model=$args[2].split(",")[3]
		$guid=$args[2].split(",")[4]
		$platformGuid=$args[2].split(",")[5]
		$macAddress=$args[2].split(",")[6].split("?")
		$ipsubnet=$args[2].split(",")[7]
		$osnames=$args[2].split(",")[8].split(":")
		$driverpackversion=$args[2].split(",")[9]
		$ipaddresses=$args[2].split(",")[10]
	
        $isExistingHost=$false
        $testvar=$args.Count
          
         
       
		#Step 2. Get the Site Code
        Import-Module -Name "$(split-path $Env:SMS_ADMIN_UI_PATH)\ConfigurationManager.psd1"
	   	$PSD = Get-PSDrive -PSProvider CMSite
	    if($PSD -eq $null){
			New-PSDrive -Name "LOCAL" -PSProvider CMSite -Root $args[1]
			$PSDN = Get-PSDrive -PSProvider CMSite -Name "LOCAL"
			$SiteCode= CD "$($PSDN):"
		}else{
	        $SiteCode= CD "$($PSD):"	
		}
	    $VMMobj= Get-CMSite
        if ( $VMMobj -ne $null ){
			
			$site=$VMMobj.SiteCode
	    }else{
			return "Site Code of the SC was not identified"
		}
		
		#step 3. get the customcollectionqueryid from new Guid
		[System.Guid] $guidObject = [System.Guid]::NewGuid()
		$customcollectionqueryid="dell_"+$guidObject.Guid
		
		$tempHostName=$hostname
		
		#step 4. check if the guid is present in SMS_R_SYSTEM
		$query="Select NETBIOSNAME from SMS_R_System where SMBIOSGUID='$guid'"
		$ns="root\sms\site_$site"
		
		$responses=Get-WMIObject -Query $query -Namespace $ns
        
		if(![string]::IsNullOrEmpty($guid) -or $guid -ne $zeroguid){
			if(($responses -ne $null)){
				#we found the host from sms_r_system
				foreach($response in $responses){
					$hostname=$response.NETBIOSNAME
				}
			}
		}else{
			$hostname=""
		}
		
		#Step 5. if the hostname was not found in sms_r_system then check if any row is available for temphostname
		
		if([string]::IsNullorEmpty($hostname)){
			$query="Select * from SMS_R_System where NETBIOSNAME='$tempHostName'"
			$responses=Get-WMIObject -Query $query -Namespace $ns
			
                    
			if(($responses -ne $null)){
				
				$hostname=$tempHostName
				#proceed to is ExistingHost flow
				$isExistingHost=$true
			}else{
				
				#Step 6. If the host occurence is not found in sms_r_system, then check if macadress is present in sms_r_system. 
				
				foreach($macadd in $macAddress){
					$query="Select NETBIOSNAME from SMS_R_SYSTEM where MACAddresses='$macadd'"
					$responses=Get-WMIObject -Query $query -Namespace $ns
					
 
					if(($responses -ne $null)){
						foreach($response in $responses){
							if(![string]::IsNullorEmpty($response.NETBIOSNAME)){
								$hostname=$response.NETBIOSNAME
							}else{
								$hostname=""
							}
						}
					}
				}
				
				if([string]::IsNullorEmpty($hostname)){
					return "Status:FAIL,Message:The Host was not found"
				}
			}
			
		}else{
			#host was found by guid in sms_r_system, go to isExistingHost()
			$isExistingHost=$true
		}
		
		#Step 7. If Host Exist, then perform the below
		if($isExistingHost -eq $true){
			$deployedOSList= @()
			#$isall=isHostPresentInCollection $hostnameparam $nsparam
			
		
			$doescollectionexist=$false
			#check if the host is present in Collection All system $collectionNameAllSystems
			$query="Select * from SMS_Collection WHERE Name='$collectionNameAllSystems'"
		
			$responses=Get-WMIObject -Query $query -Namespace $ns
			
			if(($responses -ne $null)){
				#the collection exists
				$doescollectionexist= $true
			}
			
			$collectionId=""
			if($doescollectionexist -eq $true){
				#get the collection id
				$query="Select CollectionID from SMS_Collection WHERE Name='$collectionNameAllSystems'"
				$responses=Get-WMIObject -Query $query -Namespace $ns
		
				
				if(($responses -ne $null)){
		
					foreach($response in $responses){
		
						$collectionId=$response.CollectionID
					}
				}
			}
			
		
			$hostinCollectionExist=$false
			if(![string]::IsNullorEmpty($collectionId)){
				$query="SELECT * FROM SMS_FullCollectionMembership WHERE CollectionID = '$collectionId'"
				$responses=Get-WMIObject -Query $query -Namespace $ns
		
				
				if(($responses -ne $null)){
					foreach($response in $responses){
						if($hostname -match $response.Name){
							$hostinCollectionExist=$true
							break
						}
					}
				}
			}
			
			$isall= $hostinCollectionExist
		
		
			if($isall -eq $true){
				$query="Select * from SMS_R_SYSTEM WHERE NETBIOSNAME='$hostname'"
				$responses=Get-WMIObject -Query $query -Namespace $ns
			
		
				if(($responses -ne $null)){
					foreach($row in $responses){
					
						$collectionName=(getAllCollection $hostname $ns)
						
		
						if($row.Client -eq "1"){	
							#if the client is installed 
							if(![string]::IsNullOrEmpty($row.OperatingSystemNameandVersion)){
								$index=0
								#get the index from which the version starts in OperatingSystemNameandVersion from WMI
								foreach($versionIndex in $osNameVersionIndex){
									if($row.OperatingSystemNameandVersion -match $versionIndex){
										$tempindex=$row.OperatingSystemNameandVersion.IndexOf($versionIndex)
									}
									if($tempindex -lt $index -or $index -eq 0){
										$index=$tempindex
									}
								}
					
								$oname=$row.OperatingSystemNameandVersion.SubString(0,$index)
								$oversion=$row.OperatingSystemNameandVersion.SubString($index)
								#$collectionName=(getAllCollection $hostnameparam $nsparam)
								
								$deployedOSList=$deployedOSList+@($row.SMBIOSGUID,$row.IPAddresses,$row.Name,"",$oname,$oversion,$collectionName)
							}
						}else{
							#For Non OS host, get the OS Name from iDrac
							$queryIdrac="Select * from SMS_R_iDRAC where NetbiosName = '$hostname'"
							$resultIdrac=Get-WMIObject -Query $queryIdrac -Namespace $ns
				
		
							foreach($singleResult in $resultIdrac){
								if(![string]::IsNullOrEmpty($singleResult.OSName)){
									#$collectionName=(getAllCollection $hostnameparam $nsparam)
									
									if(($singleResult.OSName.ToLower() -match $osRhel) -or ($singleResult.OSName.ToLower() -match $osEsxi)){
						
										$deployedOSList=$deployedOSList+@($row.SMBIOSGUID,$row.IPAddresses,$row.Name,"",$singleResult.OSName,"",$collectionName)
									}
								}
							}
						}
					}
				}
			}else{
		
				$deployedOSList= $null
			}		
			
			#Step 8. If host details were found then delete the old DDR and then create a new Entry with collection and DDR
			if($deployedOSList -ne $null){
				$nonWindowsOSDeployed="" 
				if(![string]::IsNullorEmpty($isHostPresent[4])){
					#the 4th index contains the OSName
					$nonWindowsOSDeployed=$isHostPresent[4]
	
				}
				
				#Start deleting the old DDR
				$queryDelIdrac="Select NetbiosName from SMS_R_iDRAC where SMBIOSGUID = '$guid'"
				$queryResultsforIdrac=Get-WMIObject -Query $queryDelIdrac -Namespace $ns
			
				
				if($queryResultsforIdrac -ne $null){
					foreach($queryResultforIdrac in $queryResultsforIdrac){
					
						$netbiosname=$queryResultforIdrac.NetbiosName
					
						$comp = [wmi]"\\.\root\sms\site_$siteCode:sms_r_idrac.NetbiosName=$($queryResultforIdrac.NetbiosName)"
						#delete the entry from SMS_R_iDRAC
						$comp.psbase.delete()
					
						if(![string]::IsNullOrEmpty($netbiosname)){
							$queryDelSystem="Select resourceID from SMS_R_System WHERE SMBIOSGUID = '$guid'"
							$queryResultsforSystem=Get-WMIObject -Query $queryDelSystem -Namespace $ns
						
							if($queryResultsforSystem -ne $null){
								foreach($queryResultforSystem in $queryResultsforSystem){
								
									$comp = [wmi]"\\.\root\sms\site_$($siteCode):sms_r_system.resourceID=$($queryResultforSystem.ResourceId)"
									#delete the entry from SMS_R_SYSTEM
									$comp.psbase.delete()
								}
							}else{
								#return "Status:$response_FAIL,Message:Unable to find idrac from SmbiosGUID in SMS_R_System"
							}
						}else{
							#return "Status:$response_FAIL,Message:Unable to find idrac from NetbiosName in SMS_R_IDRAC"
						}
					}
				}else{
					#return "Status:$response_FAIL,Message:Unable to find idrac from SmbiosGUID in SMS_R_IDRAC"
				}
			#Finished deleting the old DDR
			
			#The next step of creating new DDR, followed by Collection member will be done in post-GetHostForSCCM.ps1
				return $nonWindowsOSDeployed
			}else{
				$isNoMatchingHost=$true
				return "Status:$response_FAIL,Message:Host DOES not EXISt"
			}
		}		
	
	}-Args $DomainUsername,$ComputerName,$SccmSmBiosGuid -ErrorVariable errmsg  2>$null
	
	if ($emsg -match "FAIL"){
        $returnval=$returnval+"FAIL"
        $returnval=$returnval+$emsg
    }else{
        $returnval=$returnval+"SUCCESS"
        $returnval=$returnval+$emsg
		#here $emsg should be the $nonWindowsOSDeployed
    }
	return $returnval
	
}catch{
	$returnval=$returnval+"FAIL"
	$returnval=$returnval+$_.Exception.Message
	return $returnval
}